/*
 *  Copyright (C) 2004 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef         __DECLARATION
#define         __DECLARATION
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <net/if.h>
#include <netinet/if_ether.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <linux/sockios.h>
#include <unistd.h>
#include <fcntl.h>
#include <asm/poll.h>
#include <linux/if_packet.h>
#include  <netdb.h>
#include <semaphore.h>
#include <errno.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include "OS_Detect.h"
#include "Debug.h"
typedef unsigned char gboolean;

#ifndef FALSE
#define FALSE 0
#endif
#ifndef TRUE
#define TRUE  1
#endif

/* Semaphore utilise pour limite le nombre de thread_scan */
sem_t     Semaphore_Nouvelle_Machine;
sem_t     Semaphore_Thread_Scan;
sem_t     Semaphore_Calcul_Utilisation_Reseau;
sem_t	  Semaphore_Control_Usage_Socket;
char      pwd_Utilisateur[255];
unsigned int Nb_Octet_Envoye;
unsigned int Nb_Octet_Recu;
int Nb_Socket_Ouverte;


extern void Message (char *, int);
extern void Message_Info ();
extern void Message_Machine (char *, int, int, char *);
extern void Message_Machine_Index (char *, int, int, char *, int);
extern void Message_Machine_Taille_Total (char *, int, int, char *, int);
extern void demmarage_Thread (void *, int);
extern int Valeur_Semaphore (sem_t *);
extern char *Recupere_Banniere_FTP (char *, int);
extern char *Recupere_Banniere_HTTP (char *, int);
extern char *Recupere_Banniere_IMAP (char *, int);
extern char *Recupere_Banniere_TELNET (char *, int);
extern void Creer_Liste_Sous_Reseau ();
extern void Refresh (int);
extern void *Thread_Recherche_Ip ();
extern void *ScanMachine (int);
extern void *Nouveau_Sous_Reseau (int);
extern void Initialise_Structure_Sous_Reseau ();
extern void *Client_Nessus (int);
extern void Nouvelle_Requete_Icmp_Timestamp (struct struct_Reponse *, int, char *);
extern void Nouvelle_Requete_Ping (struct struct_Reponse *, int, char *);
extern void Nouvelle_Requete_UDP (struct struct_Reponse *, int, int, char *);
extern void Nouveau_Octet_Envoye (int);
extern void Nouveau_Octet_Recu (int);
extern void Exit_Probleme_Trouver ();
extern int close_control (int );
extern int socket_control (int, int,int); 


#endif
