 /*
  *  Copyright (C) 2004 Thierry Lagarde <tlagarde@user.sourceforge.net>
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
  *  the Free Software Foundation; either version 2 of the License, or
  *  (at your option) any later version.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  *  GNU Library General Public License for more details.
  *
  *  You should have received a copy of the GNU General Public License
  *  along with this program; if not, write to the Free Software
  *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
  */

#include "Reseau.h"
#include <stdio.h>
#include <netdb.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <string.h>
#include <openssl/ssl.h>
#include <openssl/evp.h>
#include <pthread.h>




void      Message_Machine (char *Message, int Taille_Message, int type, char *Adresse_Ip);
void      Message_Machine_Taille_Total (char *Message, int Taille_Message, int type, char *Adresse_Ip, int Taille_Total_Message);


void Envoie_Nessus (char *text, SSL * ssl)
{
	//printf("%s",text,strlen(text));
	if (SSL_write (ssl, text, strlen (text)) != strlen (text)) {
		debug_printf(D_ERRO,"Erreur : SSL_write\n");
		/*EVP_cleanup ();
		 * SSL_CTX_free (ssl_ctx);
		 * SSL_free (ssl);
		 * close (Socket); */
		pthread_exit (NULL);
	}
}


void Doit_Recevoir_Nessus (char *text, SSL * ssl)
{
	char      buf[100];
	int       Donnee_Lu;

	Donnee_Lu = SSL_read (ssl, buf, 100);
	buf[Donnee_Lu] = 0;
	//printf("Reception : [%s] (%d)\n",buf,strlen(buf));
	if (strcmp (buf, text) != 0) {
		debug_printf(D_ERRO,"Erreur : Pas de [%s]\n", text);
		/*EVP_cleanup ();
		 * SSL_CTX_free (ssl_ctx);
		 * SSL_free (ssl);
		 * close (Socket); */
		pthread_exit (NULL);
	}
}


void     *Client_Nessus (int Machine)
{
	char      buf[10000], *pbuf = NULL, *pbuf_Fin = NULL;
	char      serveur[20], Type_message[10];
	int       port, i, nb_Morceau_Donnee, Taille_Dernier_Morceau, Taille_Total_Message;
	int       opt, Etat, Num_Plugin;
	int       Donnee_Lu;
	BIO      *io, *ssl_bio;
	FILE     *Fichier_Init_Nessus;
	int       Liste_Plugin[10000], Nb_Plugin, Index_plugin;
	int       Socket;
	struct hostent *host;
	static SSL_METHOD *ssl_method = NULL;
	static SSL_CTX *ssl_ctx = NULL;
	SSL      *ssl = NULL;
	int       Index_Chaine;



	strcpy (serveur, "localhost");
	port = 1241;
	debug_printf(D_ALL,"[S] Client Nessus pour %s\n", Liste_Machines[Machine].Adresse_Ip);
	/* Initialisation Lib OpenSSL */
	SSL_library_init ();
	SSL_load_error_strings ();
	/* Initialisation du contexte OpenSSL */
	if ((ssl_method = TLSv1_client_method ()) == NULL) {
		debug_printf(D_ERRO,"[S] Erreur : Methode client TLSv1\n");
		pthread_exit (NULL);
	}
	if ((ssl_ctx = SSL_CTX_new (ssl_method)) == NULL) {
		debug_printf(D_ERRO,"[S] Erreur : SSL_CTX_new\n");
		pthread_exit (NULL);
	}
	if (SSL_CTX_set_options (ssl_ctx, SSL_OP_ALL) < 0)
		debug_printf(D_ERRO,"[S] SSL_CTX_set_options(SSL_OP_ALL)\n");

	if ((ssl = SSL_new (ssl_ctx)) == NULL) {
		debug_printf(D_ERRO,"[S] Erreur : SSL_new\n");
		SSL_CTX_free (ssl_ctx);
		pthread_exit (NULL);
	}
	/* Création du socket et connection */
	if ((Socket = Creation_Socket_TCP ()) == FALSE) {
		debug_printf(D_ERRO,"[S] Erreur : Creation Socket\n");
		EVP_cleanup ();
		SSL_CTX_free (ssl_ctx);
		SSL_free (ssl);
		pthread_exit (NULL);
	}
	opt = 1;
	setsockopt (Socket, SOL_SOCKET, SO_KEEPALIVE, &opt, sizeof (opt));

	if ((host = resoudre_DNS (serveur)) == NULL) {
		EVP_cleanup ();
		SSL_CTX_free (ssl_ctx);
		SSL_free (ssl);
		close_control (Socket);
		pthread_exit (NULL);
	}
	if (connection_Serveur (serveur, host, port, Socket) == FALSE) {
		Message ("Error Nessus :  connect on port 1241", ERREUR);
		EVP_cleanup ();
		SSL_CTX_free (ssl_ctx);
		SSL_free (ssl);
		close_control (Socket);
		pthread_exit (NULL);
	}
	debug_printf(D_ALL,"[S] Associe le descripteur de socket au contexte SSL\n");
	if (!SSL_set_fd (ssl, Socket)) {
		debug_printf(D_ERRO,"[S] Erreur : SSL_set_fd\n");
		EVP_cleanup ();
		SSL_CTX_free (ssl_ctx);
		SSL_free (ssl);
		close_control (Socket);
		pthread_exit (NULL);
	}

	debug_printf(D_ALL,"[S] Etablissement du tunnel SSL\n");
	if (SSL_connect (ssl) <= 0) {
		debug_printf(D_ERRO,"[S] Erreur : SSL_connect\n");
		Message ("Error Nessus:  SSL_connect", ERREUR);
		EVP_cleanup ();
		SSL_CTX_free (ssl_ctx);
		SSL_free (ssl);
		close_control (Socket);
		pthread_exit (NULL);
	}

	Envoie_Nessus ("< NTP/1.2 ><>\n", ssl);
	Doit_Recevoir_Nessus ("< NTP/1.2 >\n", ssl);
	Doit_Recevoir_Nessus ("User : ", ssl);
	Envoie_Nessus (Nessus_Login, ssl);
	Doit_Recevoir_Nessus ("Password : ", ssl);
	Envoie_Nessus (Nessus_Password, ssl);
	//Doit_Recevoir_Nessus ("SERVER <|> PLUGIN_LIST <|>\n", ssl);
	Donnee_Lu = SSL_read (ssl, buf, 100);
	buf[Donnee_Lu] = 0;
	if (strcmp (buf, "SERVER <|> PLUGIN_LIST <|>\n") != 0) {
		EVP_cleanup ();
		SSL_CTX_free (ssl_ctx);
		SSL_free (ssl);
		close_control (Socket);
		Message ("Nessus : Login failed", ERREUR);
		pthread_exit (NULL);
	}




	debug_printf(D_ALL,"[S] Reception de la liste de plugins : ");
	Etat = 1;
	io = BIO_new (BIO_f_buffer ());
	ssl_bio = BIO_new (BIO_f_ssl ());
	BIO_set_ssl (ssl_bio, ssl, BIO_CLOSE);
	BIO_push (io, ssl_bio);

	Nb_Plugin = 0;
	while (Etat != 6) {
		BIO_gets (io, buf, 10000 - 1);
		//printf("[%s]\n",buf);

		if ((Etat == 1) && (strcmp (buf, "<|> SERVER\n") == 0)) {
			Etat = 2;	// FIN reception liste plugins
			debug_printf(D_ALL,"[S] OK (%d Plugins)\n", Nb_Plugin);
		}

		if (Etat == 1) {
			/* Recuperation de la liste des plugins */
			if (sscanf (buf, "%d <|>", &Num_Plugin) != 1) {
				debug_printf(D_ERRO,"[S] Erreur : Recuperation Numero du plugin\n");
				pthread_exit (NULL);
			}
			pbuf = strstr (buf, "<|>");
			pbuf = pbuf + sizeof ("<|>");
			pbuf = strstr (pbuf, "<|>");
			pbuf = pbuf + sizeof ("<|>");
			pbuf[strstr (pbuf, "<|>") - pbuf] = 0;
			/*  on enleve les types "kill_host" "flood" "denial" "destructive_attack" "scanner" */
			if (((strncmp (pbuf, "kill_host", 9) != 0))&& (strncmp (pbuf, "flood", 5) != 0)&& (strncmp (pbuf, "denial", 6) != 0)&& (strncmp (pbuf, "destructive_attack", 18) != 0)&& (strncmp (pbuf, "scanner", 7) != 0)) {
				//printf("Num plugin : [%d] Type : [%s]\n",Num_Plugin,pbuf);
				Liste_Plugin[Nb_Plugin] = Num_Plugin;
				Nb_Plugin++;
			}
		}


		if ((Etat == 2) && (strcmp (buf, "SERVER <|> PREFERENCES <|>\n") == 0)) {
			Etat = 3;	// DEBUT reception liste preference
			debug_printf(D_ALL,"[S] Reception de la liste de preference : ");
		}

		if ((Etat == 3) && (strcmp (buf, "<|> SERVER\n") == 0)) {
			Etat = 4;	// FIN reception liste preference
			debug_printf(D_ALL,"[S] OK (preference)\n");
		}

		if ((Etat == 4) && (strcmp (buf, "SERVER <|> RULES <|>\n") == 0)) {
			Etat = 5;	// DEBUT reception liste regles
			debug_printf(D_ALL,"[S] Reception de la liste de regles : ");
		}

		if ((Etat == 5) && (strcmp (buf, "<|> SERVER\n") == 0)) {
			Etat = 6;	// FIN reception liste regles
			debug_printf(D_ALL,"[S] OK (regles)\n");
		}
	}



	if ((Fichier_Init_Nessus = fopen ("/usr/share/apps/AutoScan/Init1_Nessus.txt", "r")) == NULL) {
		perror ("[S] fopen :");
		debug_printf(D_ERRO,"[S] Impossible de lire Init1_Nessus.txt\n");
		pthread_exit (NULL);
	}
	while (fgets (buf, sizeof (buf), Fichier_Init_Nessus))
		Envoie_Nessus (buf, ssl);


	Index_plugin = 0;
	while (Index_plugin < Nb_Plugin) {
		sprintf (buf, "%d;", Liste_Plugin[Index_plugin]);
		Envoie_Nessus (buf, ssl);
		Index_plugin++;
	}
	fclose (Fichier_Init_Nessus);
	Envoie_Nessus ("10335;14272;10180;11840;14274;14259;\n", ssl);	//?????????????????????????????????????????

	if ((Fichier_Init_Nessus = fopen ("/usr/share/apps/AutoScan/Init2_Nessus.txt", "r")) == NULL) {
		perror ("[S] fopen :");
		debug_printf(D_ERRO,"[S] Impossible de lire Init2_Nessus.txt\n");
		pthread_exit (NULL);
	}
	while (fgets (buf, sizeof (buf), Fichier_Init_Nessus))
		Envoie_Nessus (buf, ssl);
	fclose (Fichier_Init_Nessus);

	Doit_Recevoir_Nessus ("SERVER <|> PREFERENCES_ERRORS <|>\n", ssl);
	Doit_Recevoir_Nessus ("<|> SERVER\n", ssl);
	Envoie_Nessus ("CLIENT <|> RULES <|>\n", ssl);
	Envoie_Nessus ("<|> CLIENT\n", ssl);
	Envoie_Nessus ("CLIENT <|> LONG_ATTACK <|>\n", ssl);
	sprintf (buf, "%d\n", strlen (Liste_Machines[Machine].Adresse_Ip));
	Envoie_Nessus (buf, ssl);
	sprintf (buf, "%s\n", Liste_Machines[Machine].Adresse_Ip);
	Envoie_Nessus (buf, ssl);


	while (1) {
		BIO_gets (io, buf, 10000 - 1);

		if (strncmp (buf, "SERVER <|>", 10) == 0) {
			if (strcmp (buf, "SERVER <|> BYE <|> BYE <|> SERVER\n") == 0)
				break;
			// printf("%s\n",buf);
			pbuf = strstr (buf, "<|>");
			pbuf = pbuf + sizeof ("<|>");
			/* Recuperation du type de message */
			if (sscanf (pbuf, "%s <|>", Type_message) != 1) {
				debug_printf(D_ERRO,"[S] Erreur : Recuperation type de message\n");
				pthread_exit (NULL);
			}
			if (((strncmp (pbuf, "INFO", 4) == 0)) || (strncmp (pbuf, "NOTE", 4) == 0) || (strncmp (pbuf, "HOLE", 4) == 0)) {
				//printf ("[S] Type : [%s] (%d)\n", Type_message,strlen(Type_message));
				Message_Machine (Type_message, strlen (Type_message), RETOUR_NESSUS_TYPE, Liste_Machines[Machine].Adresse_Ip);
				pbuf = strstr (pbuf, "<|>") + sizeof ("<|>");
				pbuf = strstr (pbuf, "<|>") + sizeof ("<|>");
				pbuf_Fin = strstr (pbuf, "<|>") + sizeof ("<|>");

				/* Recuperation de info de message */
				pbuf[strstr (pbuf, "<|>") - pbuf] = 0;
				//printf ("[S] Info : [%s]\n", pbuf);
				Message_Machine (pbuf, strlen (pbuf), RETOUR_NESSUS_INFO, Liste_Machines[Machine].Adresse_Ip);
				/* Recuperation du message */
				pbuf = pbuf_Fin;
				pbuf[strstr (pbuf, "<|>") - pbuf] = 0;
				//printf("Message : [%s]\n",pbuf);
				//printf ("[S] Message : [%s]\n", pbuf);
				//printf("Taille Donnee : [%d]\n",strlen(pbuf));
				Taille_Total_Message = strlen (pbuf);
				nb_Morceau_Donnee = Taille_Total_Message / 255;
				Taille_Dernier_Morceau = Taille_Total_Message % 255;
				//printf("TNb de morceau : [%d] dernier morceau (%d)\n",nb_Morceau_Donnee,Taille_Dernier_Morceau);
				Index_Chaine = 0;
				if (nb_Morceau_Donnee == 0) {	// un seul morceau  <= 255 caractères
					Message_Machine_Taille_Total (pbuf, Taille_Dernier_Morceau, RETOUR_NESSUS_DONNEE, Liste_Machines[Machine].Adresse_Ip, Taille_Dernier_Morceau);
				}
				else {
					// plusieurs morceau de 255 caractères
					Message_Machine_Taille_Total (pbuf, 255, RETOUR_NESSUS_DONNEE, Liste_Machines[Machine].Adresse_Ip, Taille_Total_Message);
					Index_Chaine = Index_Chaine + 255;
					pbuf = pbuf + 255;
					for (i = 0; i < (nb_Morceau_Donnee - 1); i++) {
						Message_Machine_Index (pbuf, 255, RETOUR_NESSUS_DONNEE_SUITE, Liste_Machines[Machine].Adresse_Ip, Index_Chaine);
						pbuf = pbuf + 255;
						Index_Chaine = Index_Chaine + 255;
					}
					// puis le dernier morceau
					Message_Machine_Index (pbuf, Taille_Dernier_Morceau, RETOUR_NESSUS_DONNEE_SUITE, Liste_Machines[Machine].Adresse_Ip, Index_Chaine);
				}
			}
		}
		//printf ("[%s]\n", buf);
	}


	Message_Machine ("", 0, RETOUR_NESSUS_FIN, Liste_Machines[Machine].Adresse_Ip);
	sprintf (buf, "Completed scan security for [%s]", Liste_Machines[Machine].Adresse_Ip);
	Message (buf, INFO);
	EVP_cleanup ();
	SSL_CTX_free (ssl_ctx);
	close_control (Socket);
	debug_printf(D_ALL,"[S] Fin Client Nessus\n");
	pthread_exit (NULL);
}
