/*
 *  Copyright (C) 2004 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "Declaration.h"
#include <pthread.h>



int socket_control (int domain, int type, int protocol)
{
	int       Socket;

	if ((Socket = socket (domain, type, protocol)) != -1) {
		sem_wait (&Semaphore_Control_Usage_Socket);
		Nb_Socket_Ouverte++;
		sem_post (&Semaphore_Control_Usage_Socket);
	}

	return Socket;
}


int close_control (int fd)
{
	int       close_s;

	if ((close_s = close (fd)) != -1) {
		sem_wait (&Semaphore_Control_Usage_Socket);
		Nb_Socket_Ouverte--;
		sem_post (&Semaphore_Control_Usage_Socket);
	}	

	return close_s;
}



void Nouveau_Octet_Envoye (int Nb_Octet)
{
	sem_wait (&Semaphore_Calcul_Utilisation_Reseau);
	Nb_Octet_Envoye = Nb_Octet_Envoye + Nb_Octet;
	if (Nb_Octet < 0) {
		debug_printf(D_ERRO,"Erreur Nouveau_Octet_Envoye %d   +%d\n", Nb_Octet_Envoye, Nb_Octet);
	}
	sem_post (&Semaphore_Calcul_Utilisation_Reseau);
}

void Nouveau_Octet_Recu (int Nb_Octet)
{
	sem_wait (&Semaphore_Calcul_Utilisation_Reseau);
	Nb_Octet_Recu = Nb_Octet_Recu + Nb_Octet;
	if (Nb_Octet < 0) {
		debug_printf(D_ERRO,"Erreur Nouveau_Octet_Recu %d   +%d\n", Nb_Octet_Recu, Nb_Octet);
	}
	sem_post (&Semaphore_Calcul_Utilisation_Reseau);
}

int Valeur_Semaphore (sem_t * sem)
{
	int       valeur;

	sem_getvalue (sem, &valeur);
	return valeur;
}


void demmarage_Thread (void *thread, int NumMachine)
{
	pthread_t pThread;

	if (pthread_create (&pThread, NULL, (void *) thread, (void *) NumMachine) != 0) {
		debug_printf(D_ERRO,"[S] Erreur Demmarage_Thread (%d): Impossible de démarrer le thread pour la machine %d\n", getpid (), NumMachine);
		Exit_Probleme_Trouver ();
	}
	pthread_detach (pThread);
}
