 /*
  *  Copyright (C) 2004 Thierry Lagarde <tlagarde@user.sourceforge.net>
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
  *  the Free Software Foundation; either version 2 of the License, or
  *  (at your option) any later version.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  *  GNU Library General Public License for more details.
  *
  *  You should have received a copy of the GNU General Public License
  *  along with this program; if not, write to the Free Software
  *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
  */



#include "callbacks.h"
#include "Reseau.h"
#include "Debug.h"

extern void load_file_html (const gchar * filename);



void on_window_Contributions_destroy (GtkObject * object, gpointer user_data)
{
	window_Contributions = create_window_Contributions ();
}




void on_button_Contributions_clicked (GtkButton * button, gpointer user_data)
{
	gtk_widget_hide (window_Contributions);
}


void Affiche_Contributions (char *Nom, char *Signature, char *Type)
{
	char      temp[255];

	gtk_text_set_point (GTK_EDITABLE (textview_Contributions), 0);
	gtk_text_forward_delete (GTK_EDITABLE (textview_Contributions), gtk_text_get_length (GTK_EDITABLE (textview_Contributions)));
	gtk_text_insert (GTK_EDITABLE (textview_Contributions), NULL, NULL, NULL, "Subject : Unknown Equipment\n\nSystem Name : ", 43);
	gtk_text_insert (GTK_EDITABLE (textview_Contributions), NULL, NULL, NULL, Nom, strlen (Nom));
	gtk_text_insert (GTK_EDITABLE (textview_Contributions), NULL, NULL, NULL, "\nMD5 signature : ", 17);
	gtk_text_insert (GTK_EDITABLE (textview_Contributions), NULL, NULL, NULL, Signature, strlen (Signature));
	gtk_text_insert (GTK_EDITABLE (textview_Contributions), NULL, NULL, NULL, "\nType : ", 8);
	gtk_text_insert (GTK_EDITABLE (textview_Contributions), NULL, NULL, NULL, Type, strlen (Type));
	gtk_widget_show (window_Contributions);

}



#define VERSION_A "0.95_R1"


gboolean vfs_Envoie_Signature (gchar * Nom, gchar * Signature, gchar * Type, int Nb_Port_Ouvert, char *Adresse_MAC, char *ftp, char *http, char *imap, char *telnet, char *spooler, char *EnteteFTP, char *EnteteHTTP, char *EnteteIMAP, char *EnteteTELNET, char *DebugSignature)
{
	char     *Tmp;
	int       i, taille_chaine;
	gboolean  retour;
	char      Nb_Port[5];

	sprintf (Nb_Port, "%d", Nb_Port_Ouvert);
	taille_chaine = sizeof ("http://autoscan.free.fr/Add_OS_Fingerprinting_Interne_V4.php?Version=" VERSION_A "&System_Name=&MD5_signature=&Type=&NB_PORT_OUVERT=&ADRESSE_MAC=&PORT_FTP=&PORT_HTTP=&PORT_IMAP=&PORT_TELNET=&PORT_SPOOLER=&ENTETE_FTP=[]&ENTETE_HTTP=[]&ENTETE_IMAP=[]&ENTETE_TELNET=[]&DEBUG_SIGNATURE=")
		+ strlen (Nom) + strlen (Signature) + strlen (Type) + strlen (Adresse_MAC) + strlen (ftp) + strlen (http) + strlen (imap) + strlen (telnet) + strlen (spooler) + strlen (EnteteFTP) + strlen (EnteteHTTP) + strlen (EnteteIMAP) + strlen (EnteteTELNET) + strlen (DebugSignature) + strlen (Nb_Port);
	debug_printf (D_ALL, "[I] taille malloc (%d)\n", taille_chaine);
	Tmp = malloc (sizeof (char) * taille_chaine);
	sprintf (Tmp, "http://autoscan.free.fr/Add_OS_Fingerprinting_Interne_V4.php?Version=" VERSION_A "&System_Name=%s&MD5_signature=%s&Type=%s&NB_PORT_OUVERT=%d&ADRESSE_MAC=%s&PORT_FTP=%s&PORT_HTTP=%s&PORT_IMAP=%s&PORT_TELNET=%s&PORT_SPOOLER=%s&ENTETE_FTP=[%s]&ENTETE_HTTP=[%s]&ENTETE_IMAP=[%s]&ENTETE_TELNET=[%s]&DEBUG_SIGNATURE=%s", Nom, Signature, Type, Nb_Port_Ouvert, Adresse_MAC, ftp, http, imap, telnet, spooler, EnteteFTP, EnteteHTTP, EnteteIMAP, EnteteTELNET, DebugSignature);
	if (taille_chaine != (strlen (Tmp) + 1)) {
		debug_printf (D_ERRO, "[I]  Erreur malloc  : vfs_Envoie_Signature allouer(%d)  utilise(%d)\n", taille_chaine, strlen (Tmp) + 1);
	}
	// replace les espaces pas des _
	for (i = 0; i < strlen (Tmp); i++) {
		if (Tmp[i] == ' ')
			Tmp[i] = '_';
	}

	debug_printf (D_ALL, "[I]  Web : (%s)\n", Tmp);
	retour = Telecharge_html (Tmp);
	free (Tmp);
	return retour;
}



void Ecrit_Ligne (char *buf, FILE * Fichier)
{
	if (fputs (buf, Fichier) != 1) {
		debug_printf (D_ERRO, "[I] Erreur Ecriture fichier Tmp_contrib.html\n");
		fclose (Fichier);
		Fin (ARRET);
	}
}

#define BUF_SIZE 8192

void Envoie_Signature_Html (char *Nom, char *Signature, char *Type, int Nb_Port_Ouvert, char *Adresse_MAC, char *ftp, char *http, char *imap, char *telnet, char *spooler, char *EnteteFTP, char *EnteteHTTP, char *EnteteIMAP, char *EnteteTELNET, char *DebugSignature)
{
	pid_t     pid_fils;
	gchar     buf[BUF_SIZE];
	char     *Tmp;
	char      CheminFichier[256];
	int       taille_chaine;
	char      Nb_Port[5],*Nom_encode_html;//*EnteteFTP, *EnteteHTTP, *EnteteIMAP, *EnteteTELNET,*DebugSignature;;
	FILE     *Fichier_Contrib, *Fichier_Tmp;


	if ((Fichier_Contrib = fopen ("/usr/share/apps/AutoScan/Contrib_Part1.html", "r")) == NULL) {
		perror ("[I] fopen :");
		Fin (ARRET);
	}
	/* Enregistrement du fichier html */
	sprintf (CheminFichier, "%s/.AutoScan/Tmp_contrib.html", Info_User->pw_dir);
	if ((Fichier_Tmp = fopen (CheminFichier, "w")) == NULL) {
		perror ("[I] fopen :");
		debug_printf (D_ERRO, "[I] Impossible d'ecrire fichier Tmp_contrib.html\n");
		Fin (ARRET);
	}


	while (fgets (buf, sizeof (buf), Fichier_Contrib)) {
		Ecrit_Ligne (buf, Fichier_Tmp);
	}
	fclose (Fichier_Contrib);

	sprintf (buf, "<center>- System Name : %s <br><br>", Nom);
	Ecrit_Ligne (buf, Fichier_Tmp);
	sprintf (buf, "- MD5 signature : %s<br>", Signature);
	Ecrit_Ligne (buf, Fichier_Tmp);
	sprintf (buf, "- Type : %s<br>", Type);
	Ecrit_Ligne (buf, Fichier_Tmp);
	sprintf (buf, "- Vendor code : %s<br>", Adresse_MAC);
	Ecrit_Ligne (buf, Fichier_Tmp);
	sprintf (buf, "- Header FTP :</center><br> %s<br><br>", EnteteFTP);
	Ecrit_Ligne (buf, Fichier_Tmp);
	sprintf (buf, "<center>- Header HTTP :</center><br> %s<br><br>", EnteteHTTP);
	Ecrit_Ligne (buf, Fichier_Tmp);
	sprintf (buf, "<center>- Header IMAP :</center><br> %s<br><br>", EnteteIMAP);
	Ecrit_Ligne (buf, Fichier_Tmp);
	sprintf (buf, "<center>- Header TELNET :</center><br> %s<br><br>", EnteteTELNET);
	Ecrit_Ligne (buf, Fichier_Tmp);

	if ((Fichier_Contrib = fopen ("/usr/share/apps/AutoScan/Contrib_Part2.html", "r")) == NULL) {
		perror ("[I] fopen :");
		Fin (ARRET);
	}
	while (fgets (buf, sizeof (buf), Fichier_Contrib)) {
		Ecrit_Ligne (buf, Fichier_Tmp);
	}
	fclose (Fichier_Contrib);


	Nom_encode_html = url_encode(Nom);
	sprintf (buf, "System_Name=%s&", Nom_encode_html);
	free(Nom_encode_html);
	Ecrit_Ligne (buf, Fichier_Tmp);
	sprintf (buf, "MD5_signature=%s&", Signature);
	Ecrit_Ligne (buf, Fichier_Tmp);
	sprintf (buf, "Version=%s&", VERSION_A);
	Ecrit_Ligne (buf, Fichier_Tmp);
	sprintf (buf, "Type=%s&", Type);
	Ecrit_Ligne (buf, Fichier_Tmp);
	sprintf (buf, "NB_PORT_OUVERT=%d&", Nb_Port_Ouvert);
	Ecrit_Ligne (buf, Fichier_Tmp);
	sprintf (buf, "ADRESSE_MAC=%s&", Adresse_MAC);
	Ecrit_Ligne (buf, Fichier_Tmp);
	sprintf (buf, "PORT_FTP=%s&", ftp);
	Ecrit_Ligne (buf, Fichier_Tmp);
	sprintf (buf, "PORT_HTTP=%s&", http);
	Ecrit_Ligne (buf, Fichier_Tmp);
	sprintf (buf, "PORT_IMAP=%s&", imap);
	Ecrit_Ligne (buf, Fichier_Tmp);
	sprintf (buf, "PORT_TELNET=%s&", telnet);
	Ecrit_Ligne (buf, Fichier_Tmp);
	sprintf (buf, "PORT_SPOOLER=%s&", spooler);
	Ecrit_Ligne (buf, Fichier_Tmp);
	sprintf (buf, "ENTETE_FTP=%s&", EnteteFTP);
	Ecrit_Ligne (buf, Fichier_Tmp);
	sprintf (buf, "ENTETE_HTTP=%s&", EnteteHTTP);
	Ecrit_Ligne (buf, Fichier_Tmp);
	sprintf (buf, "ENTETE_IMAP=%s&", EnteteIMAP);
	Ecrit_Ligne (buf, Fichier_Tmp);
	sprintf (buf, "ENTETE_TELNET=%s&", EnteteTELNET);
	Ecrit_Ligne (buf, Fichier_Tmp);
	sprintf (buf, "DEBUG_SIGNATURE=%s", DebugSignature);
	Ecrit_Ligne (buf, Fichier_Tmp);

	if ((Fichier_Contrib = fopen ("/usr/share/apps/AutoScan/Contrib_Part3.html", "r")) == NULL) {
		perror ("[I] fopen :");
		Fin (ARRET);
	}
	while (fgets (buf, sizeof (buf), Fichier_Contrib)) {
		Ecrit_Ligne (buf, Fichier_Tmp);
	}
	fclose (Fichier_Contrib);


	fclose (Fichier_Tmp);
	load_file_html(CheminFichier);
	/*
	 * if (!vfs_Envoie_Signature (Nom, Signature, Type, Nb_Port_Ouvert, Adresse_MAC, ftp, http, imap, telnet, spooler, EnteteFTP, EnteteHTTP, EnteteIMAP, EnteteTELNET, DebugSignature)) {
	 * 
	 * pid_fils = fork ();  // création d'un fils
	 * if (pid_fils == 0) {
	 * 
	 * sprintf (Nb_Port, "%d", Nb_Port_Ouvert);
	 * taille_chaine = sizeof ("mozilla 'http://autoscan.free.fr/Add_OS_Fingerprinting_V4.php?Version=" VERSION_A "&System_Name=&MD5_signature=&Type=&NB_PORT_OUVERT=&ADRESSE_MAC=&PORT_FTP=&PORT_HTTP=&PORT_IMAP=&PORT_TELNET=&PORT_SPOOLER=&ENTETE_FTP=[]&ENTETE_HTTP=[]&ENTETE_IMAP=[]&ENTETE_TELNET=[]&DEBUG_SIGNATURE='")
	 * + strlen (Nom) + strlen (Signature) + strlen (Type) + strlen (Adresse_MAC) + strlen (ftp) + strlen (http) + strlen (imap) + strlen (telnet) + strlen (spooler) + strlen (EnteteFTP) + strlen (EnteteHTTP) + strlen (EnteteIMAP) + strlen (EnteteTELNET) + strlen (DebugSignature) + strlen (Nb_Port);
	 * debug_printf (D_ALL,"[I] taille malloc (%d)\n", taille_chaine);
	 * Tmp = malloc (sizeof (char) * taille_chaine);
	 * sprintf (Tmp, "mozilla 'http://autoscan.free.fr/Add_OS_Fingerprinting_V4.php?Version=" VERSION_A "&System_Name=%s&MD5_signature=%s&Type=%s&NB_PORT_OUVERT=%d&ADRESSE_MAC=%s&PORT_FTP=%s&PORT_HTTP=%s&PORT_IMAP=%s&PORT_TELNET=%s&PORT_SPOOLER=%s&ENTETE_FTP=[%s]&ENTETE_HTTP=[%s]&ENTETE_IMAP=[%s]&ENTETE_TELNET=[%s]&DEBUG_SIGNATURE=%s'", Nom, Signature, Type, Nb_Port_Ouvert, Adresse_MAC, ftp, http, imap, telnet, spooler, EnteteFTP, EnteteHTTP, EnteteIMAP, EnteteTELNET, DebugSignature);
	 * if (taille_chaine != (strlen (Tmp) + 1)) {
	 * debug_printf (D_ERRO,"[I]  Erreur malloc  : Envoie_Signature_Html allouer(%d)  utilise(%d)\n", taille_chaine, strlen (Tmp) + 1);
	 * }
	 * //sprintf (Tmp, "mozilla 'http://autoscan.free.fr/Add_OS_Fingerprinting.php?System_Name=%s&MD5_signature=%s&Type=%s'", Nom, Signature, Type);
	 * debug_printf (D_ALL,"[I] Commande : [%s]\n", Tmp);
	 * system (Tmp);
	 * exit (127);
	 * }
	 * Affiche_Contributions (Nom, Signature, Type);
	 * }
	 * else {
	 * sprintf (CheminFichier, "%s/.AutoScan/Tmp.html", Info_User->pw_dir);
	 * load_file_html (CheminFichier);
	 * }
	 */
}
