 /*
  *  Copyright (C) 2004 Thierry Lagarde <tlagarde@user.sourceforge.net>
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
  *  the Free Software Foundation; either version 2 of the License, or
  *  (at your option) any later version.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  *  GNU Library General Public License for more details.
  *
  *  You should have received a copy of the GNU General Public License
  *  along with this program; if not, write to the Free Software
  *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
  */

#include "Reseau.h"
#include "Commun.h"
#include "Machine.h"
#include "callbacks.h"
#include "Debug.h"


void Affiche_Liste_Index_Nessus (int Machine, int type, GtkCTreeNode * parent_Vulnerabilite, GdkPixmap * GPixmap, GdkBitmap * GMasque)
{
	gchar    *text[1];
	struct struct_Index_Nessus *Index_Suivant;
	GtkCTreeNode *ctree;

	switch (type) {
	    case VULNERABILITE_NESSUS:
		    debug_printf (D_ALL,"[I] Liste vulnerabilité (%d)\n", Liste_Machines[Machine].Nb_Vulnerabilite_Nessus);
		    Index_Suivant = Liste_Machines[Machine].Index_Vunerabilite;
		    break;
	    case POTENTIEL_VULNERABILITE_NESSUS:
		   debug_printf (D_ALL,"[I] Liste vulnerabilité (%d)\n", Liste_Machines[Machine].Nb_Potentiel_Vunerabilite_Nessus);
		    Index_Suivant = Liste_Machines[Machine].Index_Potentiel_Vunerabilite;
		    break;
	    case NOTE_NESSUS:
		    debug_printf (D_ALL,"[I] Liste vulnerabilité (%d)\n", Liste_Machines[Machine].Nb_Info_Nessus);
		    Index_Suivant = Liste_Machines[Machine].Index_Info;
		    break;
	    default:
		    return;
	}


	while (Index_Suivant->Index_Suivant != NULL) {
		debug_printf (D_ALL,"[I]  Vulnerabilite : [%s]\n", Index_Suivant->Nom_Index);
		text[0] = g_strdup_printf (Index_Suivant->Nom_Index);
		ctree = gtk_ctree_insert_node (GTK_CTREE (ctree_Info), parent_Vulnerabilite, NULL, text, 5, GPixmap, GMasque, GPixmap, GMasque, FALSE, FALSE);
		g_free (text[0]);
		gtk_ctree_node_set_row_data (GTK_CTREE (ctree_Info), ctree, Index_Suivant);
		Index_Suivant = Index_Suivant->Index_Suivant;
	}
	debug_printf (D_ALL,"[I]  Vulnerabilite : [%s]\n", Index_Suivant->Nom_Index);
	text[0] = g_strdup_printf (Index_Suivant->Nom_Index);
	ctree = gtk_ctree_insert_node (GTK_CTREE (ctree_Info), parent_Vulnerabilite, NULL, text, 5, GPixmap, GMasque, GPixmap, GMasque, FALSE, FALSE);
	g_free (text[0]);
	gtk_ctree_node_set_row_data (GTK_CTREE (ctree_Info), ctree, Index_Suivant);
	debug_printf (D_ALL,"[I] ---------\n");
}



void Cree_Index_Nessus (int Machine, char *Type, char *Info)
{
	struct struct_Index_Nessus *Index_Suivant;


	if (strcmp (Type, "HOLE") == NULL) {
		// recherche si il y a deja un index
		if (Liste_Machines[Machine].Index_Vunerabilite == NULL) {
			debug_printf (D_ALL,"[I] VUL Creation du premier index [%s]\n", Info);
			Liste_Machines[Machine].Index_Vunerabilite = (struct struct_Index_Nessus *) malloc (sizeof (struct struct_Index_Nessus));
			Liste_Machines[Machine].Index_Vunerabilite->Nom_Index = (char *) malloc ((sizeof (char) * strlen (Info)) + 1);
			strcpy (Liste_Machines[Machine].Index_Vunerabilite->Nom_Index, Info);
			Liste_Machines[Machine].Index_Vunerabilite->Type_Nessus = VULNERABILITE_NESSUS;
			Liste_Machines[Machine].Index_Vunerabilite->Index_Suivant = NULL;
			Liste_Machines[Machine].Nb_Vulnerabilite_Nessus++;
			return;
		}
		Index_Suivant = Liste_Machines[Machine].Index_Vunerabilite;
		while ((strcmp (Index_Suivant->Nom_Index, Info) != NULL) && (Index_Suivant->Index_Suivant != NULL)) {
			Index_Suivant = Index_Suivant->Index_Suivant;
		}
		if (strcmp (Index_Suivant->Nom_Index, Info) != NULL) {
			debug_printf (D_ALL,"[I] VUL Nouveau index pour [%s]\n", Info);
			Index_Suivant->Index_Suivant = (struct struct_Index_Nessus *) malloc (sizeof (struct struct_Index_Nessus));
			Index_Suivant->Index_Suivant->Nom_Index = (char *) malloc ((sizeof (char) * strlen (Info)) + 1);
			strcpy (Index_Suivant->Index_Suivant->Nom_Index, Info);
			Index_Suivant->Index_Suivant->Type_Nessus = VULNERABILITE_NESSUS;
			Index_Suivant->Index_Suivant->Index_Suivant = NULL;
			Liste_Machines[Machine].Nb_Vulnerabilite_Nessus++;
			return;
		}
		debug_printf (D_ALL,"[I] VUL Index existant pour [%s]\n", Info);
		return;
	}
	if (strcmp (Type, "INFO") == NULL) {
		if (Liste_Machines[Machine].Index_Potentiel_Vunerabilite == NULL) {
			debug_printf (D_ALL,"[I] POT Creation du premier index [%s]\n", Info);
			Liste_Machines[Machine].Index_Potentiel_Vunerabilite = (struct struct_Index_Nessus *) malloc (sizeof (struct struct_Index_Nessus));
			Liste_Machines[Machine].Index_Potentiel_Vunerabilite->Nom_Index = (char *) malloc ((sizeof (char) * strlen (Info)) + 1);
			strcpy (Liste_Machines[Machine].Index_Potentiel_Vunerabilite->Nom_Index, Info);
			Liste_Machines[Machine].Index_Potentiel_Vunerabilite->Type_Nessus = POTENTIEL_VULNERABILITE_NESSUS;
			Liste_Machines[Machine].Index_Potentiel_Vunerabilite->Index_Suivant = NULL;
			Liste_Machines[Machine].Nb_Potentiel_Vunerabilite_Nessus++;
			return;
		}
		Index_Suivant = Liste_Machines[Machine].Index_Potentiel_Vunerabilite;
		while ((strcmp (Index_Suivant->Nom_Index, Info) != NULL) && (Index_Suivant->Index_Suivant != NULL)) {
			Index_Suivant = Index_Suivant->Index_Suivant;
		}
		if (strcmp (Index_Suivant->Nom_Index, Info) != NULL) {
			debug_printf (D_ALL,"[I] POT Nouveau index pour [%s]\n", Info);
			Index_Suivant->Index_Suivant = (struct struct_Index_Nessus *) malloc (sizeof (struct struct_Index_Nessus));
			Index_Suivant->Index_Suivant->Nom_Index = (char *) malloc ((sizeof (char) * strlen (Info)) + 1);
			strcpy (Index_Suivant->Index_Suivant->Nom_Index, Info);
			Index_Suivant->Index_Suivant->Type_Nessus = POTENTIEL_VULNERABILITE_NESSUS;
			Index_Suivant->Index_Suivant->Index_Suivant = NULL;
			Liste_Machines[Machine].Nb_Potentiel_Vunerabilite_Nessus++;
			return;
		}
		debug_printf (D_ALL,"[I] POT Index existant pour [%s]\n", Info);
		return;
	}
	if (strcmp (Type, "NOTE") == NULL) {
		if (Liste_Machines[Machine].Index_Info == NULL) {
			debug_printf (D_ALL,"[I] INF Creation du premier index [%s]\n", Info);
			Liste_Machines[Machine].Index_Info = (struct struct_Index_Nessus *) malloc (sizeof (struct struct_Index_Nessus));
			Liste_Machines[Machine].Index_Info->Nom_Index = (char *) malloc ((sizeof (char) * strlen (Info)) + 1);
			strcpy (Liste_Machines[Machine].Index_Info->Nom_Index, Info);
			Liste_Machines[Machine].Index_Info->Type_Nessus = NOTE_NESSUS;
			Liste_Machines[Machine].Index_Info->Index_Suivant = NULL;
			Liste_Machines[Machine].Nb_Info_Nessus++;
			return;
		}
		Index_Suivant = Liste_Machines[Machine].Index_Info;
		while ((strcmp (Index_Suivant->Nom_Index, Info) != NULL) && (Index_Suivant->Index_Suivant != NULL)) {
			Index_Suivant = Index_Suivant->Index_Suivant;
		}
		if (strcmp (Index_Suivant->Nom_Index, Info) != NULL) {
			debug_printf (D_ALL,"[I] INF Nouveau index pour [%s]\n", Info);
			Index_Suivant->Index_Suivant = (struct struct_Index_Nessus *) malloc (sizeof (struct struct_Index_Nessus));
			Index_Suivant->Index_Suivant->Nom_Index = (char *) malloc ((sizeof (char) * strlen (Info)) + 1);
			strcpy (Index_Suivant->Index_Suivant->Nom_Index, Info);
			Index_Suivant->Index_Suivant->Type_Nessus = NOTE_NESSUS;
			Index_Suivant->Index_Suivant->Index_Suivant = NULL;
			Liste_Machines[Machine].Nb_Info_Nessus++;
			return;
		}
		debug_printf (D_ALL,"[I] INF Index existant pour [%s]\n", Info);
		return;
	}
}



void creation_Liste_Index (int Machine)
{
	struct struct_Nessus *Nessus_Vulnerabilite;

	if (Liste_Machines[Machine].Nessus_Info_Debut != NULL) {	// teste si la donnee sont presente
		if ((Liste_Machines[Machine].Index_Vunerabilite == NULL) && (Liste_Machines[Machine].Index_Potentiel_Vunerabilite == NULL)
			&& (Liste_Machines[Machine].Index_Info == NULL)) {
			debug_printf (D_ALL,"Creation de la liste d'index Nessus\n");
			Nessus_Vulnerabilite = Liste_Machines[Machine].Nessus_Info_Debut;
			do {
				Cree_Index_Nessus (Machine, Nessus_Vulnerabilite->Type, Nessus_Vulnerabilite->Info);
			} while ((Nessus_Vulnerabilite = Nessus_Vulnerabilite->Nessus_Suivant) != NULL);
		}
		debug_printf (D_ALL,"Creation_Liste Index Fini (%d)\n", Machine);
		Liste_Machines[Machine].Nessus_Fini = TRUE;	// Ok on peut afficher
	}
	if (Machine == MachineSelectionner) {
		Affiche_Info ();
	}
}


void Affiche_Liste_Vulnerabilite (int Machine)
{
	struct struct_Nessus *Nessus_Vulnerabilite;
	int       Nb_Vulnerabilite;


	debug_printf (D_ALL,"[I]  TYPE D: [%s]\n", Liste_Machines[Machine].Nessus_Info_Debut->Type);
	debug_printf (D_ALL,"[I]       TYPE pointeur : (%s)\n", Liste_Machines[Machine].Nessus_Info_Debut->Info);
	debug_printf (D_ALL,"Affiche Liste Vulnerabilite machine (%d)\n", Machine);

	Nb_Vulnerabilite = 0;
	if (Liste_Machines[Machine].Nessus_Info_Debut != NULL) {
		Nessus_Vulnerabilite = Liste_Machines[Machine].Nessus_Info_Debut;
		do {
			Nb_Vulnerabilite++;
			debug_printf (D_ALL,"[I]  Vulnerabilite (%d)   TYPE : [%s]  INFO [%s]\n", Nb_Vulnerabilite, Nessus_Vulnerabilite->Type, Nessus_Vulnerabilite->Info);
		} while ((Nessus_Vulnerabilite = Nessus_Vulnerabilite->Nessus_Suivant) != NULL);
	}

}
