/*
 *  Copyright (C) 2004 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <time.h>
#include "Reseau.h"
#include "callbacks.h"
#include "Signature.h"
#include "Machine.h"
#include "Debug.h"

extern int h_errno;

#define FIN 		-1
#define EFFACER 	NULL
int       MachineSelectionner_Nouvelle_Signature;


void Ajoute_Nouvelle_Signature (char *buf, int Emplacement)
{
	char     *pBuf;
	int       Taille, nb;
	GdkColor  Transparent;
	GdkPixmap *Image;

	pBuf = buf;
	/* Recupere le Nom Os */
	Taille = index (pBuf, ';') - buf;
	//printf ("Taille Nom Os : %d\n", Taille);
	Liste_Signature[Emplacement].Nom = malloc (sizeof (char) + Taille + 1);
	strncpy (Liste_Signature[Emplacement].Nom, pBuf, Taille);
	Liste_Signature[Emplacement].Nom[Taille] = 0;
	/* Recepere le type */
	pBuf = pBuf + Taille + 1;
	Taille = index (pBuf, ';') - pBuf;
	if ((nb = sscanf (pBuf, "%d;", &Liste_Signature[Emplacement].Type_Machine)) != 1)
		debug_printf (D_ERRO, "[I] Erreur Lecture Type   nb lu %d\n", nb);
	/* Recupere Requete_Netbios */
	pBuf = pBuf + Taille + 1;
	Taille = index (pBuf, ';') - pBuf;
	if ((nb = sscanf (pBuf, "%d;", &Liste_Signature[Emplacement].Requete_Netbios)) != 1)
		debug_printf (D_ERRO, "[I] Erreur Lecture Requete_Netbios  nb lu %d\n", nb);
	/* Recupere Routeur ? */
	pBuf = pBuf + Taille + 1;
	Taille = index (pBuf, ';') - pBuf;
	if ((nb = sscanf (pBuf, "%d;", &Liste_Signature[Emplacement].Routeur)) != 1)
		debug_printf (D_ERRO, "[I] Erreur Lecture Routeur  nb lu %d\n", nb);
	/* Recupere Etat_Equipement */
	pBuf = pBuf + Taille + 1;
	Taille = index (pBuf, ';') - pBuf;
	if ((nb = sscanf (pBuf, "%d;", &Liste_Signature[Emplacement].Etat_Equipement)) != 1)
		debug_printf (D_ERRO, "[I] Erreur Lecture Etat_Equipement  nb lu %d\n", nb);
	/* Recupere Etat_Equipement_Eteint */
	pBuf = pBuf + Taille + 1;
	Taille = index (pBuf, ';') - pBuf;
	if ((nb = sscanf (pBuf, "%d;", &Liste_Signature[Emplacement].Etat_Equipement_Eteint)) != 1)
		debug_printf (D_ERRO, "[I] Erreur Lecture Etat_Equipement_Eteint  nb lu %d\n", nb);
	/* Recupere Etat_Equipement_Message */
	pBuf = pBuf + Taille + 1;
	Taille = index (pBuf, ';') - pBuf;
	if ((nb = sscanf (pBuf, "%d;", &Liste_Signature[Emplacement].Etat_Equipement_Message)) != 1)
		debug_printf (D_ERRO, "[I] Erreur Lecture Etat_Equipement_Message  nb lu %d\n", nb);
	/* Recupere Etat_Equipement_Email */
	pBuf = pBuf + Taille + 1;
	Taille = index (pBuf, ';') - pBuf;
	if ((nb = sscanf (pBuf, "%d;", &Liste_Signature[Emplacement].Etat_Equipement_Email)) != 1)
		debug_printf (D_ERRO, "[I] Erreur Lecture Etat_Equipement_Email  nb lu %d\n", nb);
	/* Recupere Email */
	pBuf = pBuf + Taille + 1;
	Taille = index (pBuf, ';') - pBuf;
	Liste_Signature[Emplacement].Email = malloc (sizeof (char) + Taille + 1);
	strncpy (Liste_Signature[Emplacement].Email, pBuf, Taille);
	Liste_Signature[Emplacement].Email[Taille] = 0;
	/* Recupere la signature */
	pBuf = pBuf + Taille + 1;
	Taille = index (pBuf, ';') - pBuf;
	//printf ("Taille Signature : %d\n", Taille);
	if ((nb = sscanf (pBuf, "%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X;", &Liste_Signature[Emplacement].digest[0], &Liste_Signature[Emplacement].digest[1], &Liste_Signature[Emplacement].digest[2], &Liste_Signature[Emplacement].digest[3], &Liste_Signature[Emplacement].digest[4], &Liste_Signature[Emplacement].digest[5], &Liste_Signature[Emplacement].digest[6], &Liste_Signature[Emplacement].digest[7], &Liste_Signature[Emplacement].digest[8], &Liste_Signature[Emplacement].digest[9], &Liste_Signature[Emplacement].digest[10], &Liste_Signature[Emplacement].digest[11], &Liste_Signature[Emplacement].digest[12], &Liste_Signature[Emplacement].digest[13], &Liste_Signature[Emplacement].digest[14], &Liste_Signature[Emplacement].digest[15])) != 16)
		debug_printf (D_ERRO, "[I] Erreur Lecture signature MD5   nb lu %d\n", nb);
	//strncpy (Liste_Signature[Emplacement].digest, pBuf, Taille);
	Liste_Signature[Emplacement].digest[16] = 0;
	/* Recupere la icone */
	pBuf = pBuf + Taille + 1;
	Taille = index (pBuf, ';') - pBuf;
	//printf ("Taille icone : %d\n", Taille);
	Liste_Signature[Emplacement].Fichier_Icone = malloc (sizeof (char) + Taille + 1);
	strncpy (Liste_Signature[Emplacement].Fichier_Icone, pBuf, Taille);
	Liste_Signature[Emplacement].Fichier_Icone[Taille] = 0;
	Liste_Signature[Emplacement].Image = gdk_pixmap_create_from_xpm (window->window, &Liste_Signature[Emplacement].Masque, &Transparent, Liste_Signature[Emplacement].Fichier_Icone);
	if (Liste_Signature[Emplacement].Image == NULL) {
		debug_printf (D_WARN, "[I] Erreur chargement Image OS \n");
	}
	/* Recupere la icone Eteint */
	pBuf = pBuf + Taille + 1;
	Taille = index (pBuf, ';') - pBuf;
	//printf ("Taille icone : %d\n", Taille);
	Liste_Signature[Emplacement].Fichier_Icone_Eteint = malloc (sizeof (char) + Taille + 1);
	strncpy (Liste_Signature[Emplacement].Fichier_Icone_Eteint, pBuf, Taille);
	Liste_Signature[Emplacement].Fichier_Icone_Eteint[Taille] = 0;
	Liste_Signature[Emplacement].Image_Eteint = gdk_pixmap_create_from_xpm (window->window, &Liste_Signature[Emplacement].Masque_Eteint, &Transparent, Liste_Signature[Emplacement].Fichier_Icone_Eteint);
	if (Liste_Signature[Emplacement].Image_Eteint == NULL) {
		debug_printf (D_WARN, "[I] Erreur chargement Image OS Eteint \n");
	}
}



void Creer_SignatureList ()
{
	FILE     *Fichier_SignatureList;
	char      buf[512], CheminFichier[255];
	int       i;

	sprintf (CheminFichier, "%s/.AutoScan/Conf/FingerPrinting", Info_User->pw_dir);
	if ((Fichier_SignatureList = fopen (CheminFichier, "r")) == NULL) {
		perror ("[I] fopen :");
		debug_printf (D_ERRO, "[I] Impossible de lire SignatureListe\n");
		exit (-1);
	}
	Nb_Signature = 0;
	while (fgets (buf, sizeof (buf), Fichier_SignatureList))
		Nb_Signature++;
	rewind (Fichier_SignatureList);
	Liste_Signature = (struct struct_Liste_Signature *) malloc (sizeof (struct struct_Liste_Signature) * (Nb_Signature + 1));
	Nb_Signature = 0;

	while (fgets (buf, sizeof (buf), Fichier_SignatureList)) {
		Ajoute_Nouvelle_Signature (buf, Nb_Signature);
		Nb_Signature++;
	}
	Liste_Signature[Nb_Signature].Nom = FIN;	//FIN
	/* Initialisation des la dernière signature a FFFFFF...  */
	for (i = 0; i < 16; i++)
		Liste_Signature[Nb_Signature].digest[i] = 0xFF;
	debug_printf (D_INFO, "[I] Creation de la liste des signatures (%d signatures trouves)\n", Nb_Signature);
	fclose (Fichier_SignatureList);
}




void Init_Info_Signature ()
{
/* Initialise l interface */
	Modif_Signature = TRUE;	// permet de ne pas prendre en compte les modifications par la fonction Liste_Port_changed
	gnome_icon_entry_set_filename (iconentry_Liste_Signature_Allumer, NULL);
	gnome_icon_entry_set_filename (iconentry_Liste_Signature_Eteint, NULL);
	gtk_widget_set_sensitive (ctree_Liste_Signatures, TRUE);
	gtk_entry_set_text (GTK_ENTRY (entry_Liste_Signatures_Nom), "");
	gtk_entry_set_text (GTK_ENTRY (entry_Liste_Signatures_md5), "");
	gtk_entry_set_text (GTK_ENTRY (entry_Liste_Signatures_Etat_Action_Email), "");
	gtk_widget_set_sensitive (button_Liste_Signatures_Ajouter, TRUE);
	gtk_widget_set_sensitive (button_Liste_Signatures_Sauvegarder, TRUE);
	gtk_widget_set_sensitive (button_Liste_Signatures_Ok, FALSE);
	gtk_widget_set_sensitive (button_Liste_Signatures_Annuler, FALSE);
	gtk_widget_set_sensitive (entry_Liste_Signatures_Nom, FALSE);
	gtk_widget_set_sensitive (entry_Liste_Signatures_md5, FALSE);
	gtk_widget_set_sensitive (iconentry_Liste_Signature_Allumer, FALSE);
	gtk_widget_set_sensitive (iconentry_Liste_Signature_Eteint, FALSE);
//      gtk_widget_set_sensitive (iconentry_Liste_Signature_Eteint, FALSE);
	gtk_widget_set_sensitive (label_Liste_Signatures_Etat_Action, FALSE);
	gtk_widget_set_sensitive (combo_Liste_Signatures_Type, FALSE);
	gtk_widget_set_sensitive (checkbutton_Liste_Signatures_Routeur, FALSE);
	gtk_widget_set_sensitive (checkbutton_Liste_Signatures_NETBIOS, FALSE);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Signatures_Routeur), FALSE);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Signatures_NETBIOS), FALSE);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Signatures_Etat), FALSE);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Signatures_Etat_Down), FALSE);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Signatures_Etat_Action_Message), FALSE);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Signatures_Etat_Action_Email), FALSE);
	gtk_widget_set_sensitive (checkbutton_Liste_Signatures_Etat, FALSE);
	gtk_widget_set_sensitive (checkbutton_Liste_Signatures_Etat_Down, FALSE);
	gtk_widget_set_sensitive (checkbutton_Liste_Signatures_Etat_Action_Message, FALSE);
	gtk_widget_set_sensitive (checkbutton_Liste_Signatures_Etat_Action_Email, FALSE);
	gtk_widget_set_sensitive (entry_Liste_Signatures_Etat_Action_Email, FALSE);
	gtk_editable_set_editable (GTK_EDITABLE (entry_Liste_Signatures_Type), FALSE);
	gtk_editable_set_editable (GTK_EDITABLE (entry_Liste_Signatures_md5), FALSE);
	Signature_Selectionner = -1;
	Ajout_Signature = FALSE;
	Modif_Signature = FALSE;

}

void Change_Etat_Signature ()
{
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Signatures_Etat))) {
		gtk_widget_set_sensitive (label_Liste_Signatures_Etat_Action, TRUE);
		gtk_widget_set_sensitive (checkbutton_Liste_Signatures_Etat_Down, TRUE);
		gtk_widget_set_sensitive (checkbutton_Liste_Signatures_Etat_Action_Message, TRUE);
		gtk_widget_set_sensitive (checkbutton_Liste_Signatures_Etat_Action_Email, TRUE);
		gtk_widget_set_sensitive (entry_Liste_Signatures_Etat_Action_Email, TRUE);
	}
	else {
		gtk_widget_set_sensitive (label_Liste_Signatures_Etat_Action, FALSE);
		gtk_widget_set_sensitive (checkbutton_Liste_Signatures_Etat_Down, FALSE);
		gtk_widget_set_sensitive (checkbutton_Liste_Signatures_Etat_Action_Message, FALSE);
		gtk_widget_set_sensitive (checkbutton_Liste_Signatures_Etat_Action_Email, FALSE);
		gtk_widget_set_sensitive (entry_Liste_Signatures_Etat_Action_Email, FALSE);
	}

}

void on_checkbutton_Liste_Signatures_Etat_clicked (GtkButton * button, gpointer user_data)
{
	Change_Etat_Signature ();
}

void Affiche_liste_Signatures ()
{
	gchar    *text[2];
	char      Tmp[255];
	int       i;
	GtkCTreeNode *Node;

	Init_Info_Signature ();
	gtk_widget_set_sensitive (button_Liste_Signatures_Enlever, FALSE);
	gtk_clist_clear (GTK_CLIST (ctree_Liste_Signatures));
	gtk_clist_freeze (GTK_CLIST (ctree_Liste_Signatures));
	for (i = 0; i < Nb_Signature; i++) {
		if (Liste_Signature[i].Nom[0] != EFFACER) {
			text[0] = g_strdup_printf (Liste_Signature[i].Nom);
			sprintf (Tmp, "%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", Liste_Signature[i].digest[0], Liste_Signature[i].digest[1], Liste_Signature[i].digest[2], Liste_Signature[i].digest[3], Liste_Signature[i].digest[4], Liste_Signature[i].digest[5], Liste_Signature[i].digest[6], Liste_Signature[i].digest[7], Liste_Signature[i].digest[8], Liste_Signature[i].digest[9], Liste_Signature[i].digest[10], Liste_Signature[i].digest[11], Liste_Signature[i].digest[12], Liste_Signature[i].digest[13], Liste_Signature[i].digest[14], Liste_Signature[i].digest[15]);
			text[1] = g_strdup_printf (Tmp);
			Node = gtk_ctree_insert_node (GTK_CTREE (ctree_Liste_Signatures), NULL, NULL, text, 5, NULL, NULL, NULL, NULL, FALSE, FALSE);
			gtk_ctree_node_set_row_data (GTK_CTREE (ctree_Liste_Signatures), Node, (gpointer *) i);
			Liste_Signature[i].Node = Node;
			g_free (text[0]);
			g_free (text[1]);
		}
	}
	gtk_clist_thaw (GTK_CLIST (ctree_Liste_Signatures));
	gtk_widget_show (window_Liste_Signatures);
}

void on_liste_des_signatures_activate (GtkMenuItem * menuitem, gpointer user_data)
{
	Affiche_liste_Signatures ();
}


void on_ajouter_signature_activate (GtkMenuItem * menuitem, gpointer user_data)
{
	char      Tmp[50];
	int       Signature;


	if (!Mode_Documentation) {
		Init_Documentation ("/usr/share/doc/AutoScan/Os1.html");
		Mode_Documentation = TRUE;
		MachineSelectionner_Avant_Documentation = MachineSelectionner;
	}



	Signature = 0;
	while ((Signature < Nb_Signature) && (memcmp (Liste_Signature[Signature].digest, Liste_Machines[MachineSelectionner].digest, 16) != 0)) {
		Signature++;
	}
	debug_printf (D_ALL, "S %d   S %d\n", Nb_Signature, Signature);

	//if (Liste_Machines[MachineSelectionner].Image == NULL) {
	if (Nb_Signature == Signature) {
		Affiche_liste_Signatures ();
		Ajout_Signature = TRUE;
		MachineSelectionner_Nouvelle_Signature = MachineSelectionner;
		debug_printf (D_ALL, "[I] Ajoute une nouvelle signature Machine : (%d)\n", MachineSelectionner_Nouvelle_Signature);
		sprintf (Tmp, "%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", Liste_Machines[MachineSelectionner].digest[0], Liste_Machines[MachineSelectionner].digest[1], Liste_Machines[MachineSelectionner].digest[2], Liste_Machines[MachineSelectionner].digest[3], Liste_Machines[MachineSelectionner].digest[4], Liste_Machines[MachineSelectionner].digest[5], Liste_Machines[MachineSelectionner].digest[6], Liste_Machines[MachineSelectionner].digest[7], Liste_Machines[MachineSelectionner].digest[8], Liste_Machines[MachineSelectionner].digest[9], Liste_Machines[MachineSelectionner].digest[10], Liste_Machines[MachineSelectionner].digest[11], Liste_Machines[MachineSelectionner].digest[12], Liste_Machines[MachineSelectionner].digest[13], Liste_Machines[MachineSelectionner].digest[14], Liste_Machines[MachineSelectionner].digest[15]);
		gtk_entry_set_text (GTK_ENTRY (entry_Liste_Signatures_md5), Tmp);
		gtk_widget_set_sensitive (button_Liste_Signatures_Ajouter, FALSE);
		gtk_widget_set_sensitive (button_Liste_Signatures_Enlever, FALSE);
		gtk_widget_set_sensitive (button_Liste_Signatures_Sauvegarder, FALSE);
		gtk_widget_set_sensitive (button_Liste_Signatures_Ok, TRUE);
		gtk_widget_set_sensitive (button_Liste_Signatures_Annuler, TRUE);
		gtk_widget_set_sensitive (entry_Liste_Signatures_Nom, TRUE);
		gtk_widget_set_sensitive (entry_Liste_Signatures_md5, TRUE);
		gtk_widget_set_sensitive (iconentry_Liste_Signature_Allumer, TRUE);
		gtk_widget_set_sensitive (iconentry_Liste_Signature_Eteint, TRUE);
		gtk_widget_set_sensitive (combo_Liste_Signatures_Type, TRUE);
		gtk_widget_set_sensitive (ctree_Liste_Signatures, FALSE);
		gtk_widget_set_sensitive (checkbutton_Liste_Signatures_Routeur, TRUE);
		gtk_widget_set_sensitive (checkbutton_Liste_Signatures_NETBIOS, TRUE);
		gtk_widget_set_sensitive (checkbutton_Liste_Signatures_Etat, FALSE);	//<<<<<<<<<<<<<<<<<<<<<<<<<<<<
		Change_Etat_Signature ();
		/*gtk_widget_set_sensitive (checkbutton_Liste_Signatures_Etat_Down, TRUE);
		 * gtk_widget_set_sensitive (checkbutton_Liste_Signatures_Etat_Action_Message, TRUE);
		 * gtk_widget_set_sensitive (checkbutton_Liste_Signatures_Etat_Action_Email, TRUE);
		 * gtk_widget_set_sensitive (entry_Liste_Signatures_Etat_Action_Email, TRUE); */
		gtk_widget_show (window_Liste_Signatures);
	}
	else
		Message ("OS fingerprinting is already existing", GNOME_MESSAGE_BOX_INFO);
}


void on_button_Liste_Signatures_Ajouter_clicked (GtkButton * button, gpointer user_data)
{
	Init_Info_Signature ();
	Ajout_Signature = TRUE;
	debug_printf (D_ALL, "[I] Ajoute une nouvelle signature\n");
	gtk_widget_set_sensitive (button_Liste_Signatures_Ajouter, FALSE);
	gtk_widget_set_sensitive (button_Liste_Signatures_Enlever, FALSE);
	gtk_widget_set_sensitive (button_Liste_Signatures_Sauvegarder, FALSE);
	gtk_widget_set_sensitive (button_Liste_Signatures_Ok, TRUE);
	gtk_widget_set_sensitive (button_Liste_Signatures_Annuler, TRUE);
	gtk_widget_set_sensitive (entry_Liste_Signatures_Nom, TRUE);
	gtk_widget_set_sensitive (entry_Liste_Signatures_md5, TRUE);
	gtk_widget_set_sensitive (iconentry_Liste_Signature_Allumer, TRUE);
	gtk_widget_set_sensitive (iconentry_Liste_Signature_Eteint, TRUE);
	gtk_widget_set_sensitive (combo_Liste_Signatures_Type, TRUE);
	gtk_widget_set_sensitive (ctree_Liste_Signatures, FALSE);
	gtk_widget_set_sensitive (checkbutton_Liste_Signatures_Routeur, TRUE);
	gtk_widget_set_sensitive (checkbutton_Liste_Signatures_NETBIOS, TRUE);
	gtk_widget_set_sensitive (checkbutton_Liste_Signatures_Etat, FALSE);	//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
	Change_Etat_Signature ();
	/*
	 * gtk_widget_set_sensitive (checkbutton_Liste_Signatures_Etat_Down, TRUE);
	 * gtk_widget_set_sensitive (checkbutton_Liste_Signatures_Etat_Action_Message, TRUE);
	 * gtk_widget_set_sensitive (checkbutton_Liste_Signatures_Etat_Action_Email, TRUE);
	 * gtk_widget_set_sensitive (entry_Liste_Signatures_Etat_Action_Email, TRUE); */
}


void on_button_Liste_Signatures_Enlever_clicked (GtkButton * button, gpointer user_data)
{
	if (Signature_Selectionner != -1) {
		debug_printf (D_ALL, "[I] Suppression du signature %s\n", Liste_Signature[Signature_Selectionner].Nom);
		gtk_ctree_remove_node (ctree_Liste_Signatures, Liste_Signature[Signature_Selectionner].Node);
		Liste_Signature[Signature_Selectionner].Nom = EFFACER;
		Signature_Selectionner = -1;
		gtk_widget_set_sensitive (button_Liste_Signatures_Enlever, FALSE);
		Init_Info_Signature ();
	}
}


//" !#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`abcdefghijklmnopqrstuvwxyz{|}~€‚ƒ„…†‡ˆ‰Š‹ŒŽ‘’“”•–—˜™š›œžŸ¡¢£¤¥¦§¨©ª«¬­®¯°±²³´µ¶·¸¹º»¼½¾¿ÀÁÂÃÄÅÆÇÈÉÊËÌÍÎÏÐÑÒÓÔÕÖ×ØÙÚÛÜÝÞßàáâãäåæçèéêëìíîïðñòóôõö÷øùúûüýþÿ"

void filtreCaractere (char *Entete)
{
	int       i;

	for (i = 0; i < strlen (Entete); i++) {
		if ((Entete[i] == 10) || (Entete[i] == 13))
			Entete[i] = '||';
		else {
			if (Entete[i] == 32)
				Entete[i] = '_';
			else {
				if ((Entete[i] != '$') && (Entete[i] != '(') && (Entete[i] != ')')) {
					if (!(((Entete[i] < 59) && (Entete[i] > 38)) || ((Entete[i] < 94) && (Entete[i] > 63)) || ((Entete[i] < 123) && (Entete[i] > 96))
						)
						) {
						Entete[i] = '?';

					}
				}
			}
		}

	}
	debug_printf (D_ALL, "Entete modifier : [%s](%d)\n", Entete, strlen (Entete));

}




static unsigned char hexchars[] = "0123456789ABCDEF";

char     *url_encode (char *source)
{
	int       i, index;
	char     *resultat;

	if (source == NULL) {
		resultat = (char *) malloc ((sizeof (char)) * 7);
		strcpy (resultat, "-vide-");
		return resultat;
	}
	resultat = (char *) malloc ((sizeof (char)) * ((3 * strlen (source)) + 1));
	index = 0;
	for (i = 0; i < strlen (source); i++) {
		resultat[index] = source[i];

		if ((source[i] != '$') && (source[i] != '(') && (source[i] != ')')) {

			if (!(((source[i] < 59) && (source[i] > 38))
					|| ((source[i] < 94) && (source[i] > 63))
					|| ((source[i] < 123) && (source[i] > 96))
				)
				) {
				/*if ( (source[i] < '0' && source[i] != '-' && source[i] != '.') 
				 * || (source[i] < 'A' && source[i] > '9') 
				 * || (source[i] > 'Z' && source[i] < 'a' && source[i] != '_') 
				 * || (source[i] > 'z')) { */
				resultat[index] = '%';
				resultat[index + 1] = hexchars[(unsigned char) source[i] >> 4];
				resultat[index + 2] = hexchars[(unsigned char) source[i] & 15];
				index = index + 2;
			}
		}
		index++;
	}
	resultat[index] = '\0';
	debug_printf (D_ALL, "Resultat : [%s]\n", resultat);
	return resultat;
}






gboolean Etat_Port (int machine, int Num_port)
{
	int       i;

	i = 0;
	while (Liste_Machines[machine].Nb_Port_Ouvert != i) {
		if (Liste_Machines[machine].Port[i].Num_Port == Num_port)
			return TRUE;
		i++;
	}
	return FALSE;

}


void on_button_Liste_Signatures_Ok_clicked (GtkButton * button, gpointer user_data)
{
	gchar    *text[2], etat_ftp[20], etat_http[20], etat_imap[20], etat_telnet[20], etat_spooler[20];
	char      Tmp[512], *EnteteFTP, *EnteteHTTP, *EnteteIMAP, *EnteteTELNET, *DebugSignature;
	GtkCTreeNode *Node;
	int       type, netbios, routeur, etat, etat_down, message, email;
	unsigned char Adresse_Mac_Fournisseur[9];


	debug_printf (D_ALL, "[I] Enr   machine (%d)\n", MachineSelectionner_Nouvelle_Signature);

	/*  Vérification nom du système */
	if (strlen (gtk_entry_get_text (GTK_ENTRY (entry_Liste_Signatures_Nom))) == 0) {
		Message ("Error : System Name", GNOME_MESSAGE_BOX_ERROR);
		return;
	}

	if (Modif_Signature) {
		debug_printf (D_ALL, "[I] Suppression Modification d'une signature [%s]\n", Liste_Signature[Signature_Selectionner].Nom);
		gtk_ctree_remove_node (ctree_Liste_Signatures, Liste_Signature[Signature_Selectionner].Node);
		Liste_Signature[Signature_Selectionner].Nom = EFFACER;
	}

	type = INCONNU;
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Signatures_NETBIOS)))
		netbios = 1;
	else
		netbios = 0;
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Signatures_Routeur)))
		routeur = 1;
	else
		routeur = 0;
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Signatures_Etat)))
		etat = 1;
	else
		etat = 0;

	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Signatures_Etat_Down)))
		etat_down = 1;
	else
		etat_down = 0;

	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Signatures_Etat_Action_Message)))
		message = 1;
	else
		message = 0;

	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Signatures_Etat_Action_Email)))
		email = 1;
	else
		email = 0;


	type = 0;
	if (strcmp (gtk_entry_get_text (GTK_ENTRY (entry_Liste_Signatures_Type)), "Materiel") == 0)
		type = MATERIEL;
	if (strcmp (gtk_entry_get_text (GTK_ENTRY (entry_Liste_Signatures_Type)), "Server") == 0)
		type = SERVEUR;
	if (strcmp (gtk_entry_get_text (GTK_ENTRY (entry_Liste_Signatures_Type)), "WorkStation") == 0)
		type = STATION;
	if (strcmp (gtk_entry_get_text (GTK_ENTRY (entry_Liste_Signatures_Type)), "Switch") == 0)
		type = SWITCH;
	if (strcmp (gtk_entry_get_text (GTK_ENTRY (entry_Liste_Signatures_Type)), "Printer") == 0)
		type = IMPRIMANTE;
	if (strcmp (gtk_entry_get_text (GTK_ENTRY (entry_Liste_Signatures_Type)), "Other") == 0)
		type = AUTRE;
	if (strcmp (gtk_entry_get_text (GTK_ENTRY (entry_Liste_Signatures_Type)), "Router") == 0)
		type = ROUTEUR;
	if (strcmp (gtk_entry_get_text (GTK_ENTRY (entry_Liste_Signatures_Type)), "Router-Switch") == 0)
		type = ROUTEUR_SWITCH;
	if (strcmp (gtk_entry_get_text (GTK_ENTRY (entry_Liste_Signatures_Type)), "Wifi") == 0)
		type = POINT_ACCESS_WIFI;
	if (type == 0) {
		Message ("Error : Type", GNOME_MESSAGE_BOX_ERROR);
		return;
	}

	debug_printf (D_ALL, "[I] Ajout d'une signature [%s]\n", gtk_entry_get_text (GTK_ENTRY (entry_Liste_Signatures_Nom)));
	sprintf (Tmp, "%s;%d;%d;%d;%d;%d;%d;%d;%s;%s;%s;%s;\n", gtk_entry_get_text (GTK_ENTRY (entry_Liste_Signatures_Nom)), type, netbios, routeur, etat, etat_down, message, email, gtk_entry_get_text (GTK_ENTRY (entry_Liste_Signatures_Etat_Action_Email)), gtk_entry_get_text (GTK_ENTRY (entry_Liste_Signatures_md5)), gnome_icon_entry_get_filename (iconentry_Liste_Signature_Allumer), gnome_icon_entry_get_filename (iconentry_Liste_Signature_Eteint));
	debug_printf (D_ALL, "[I] Buf : [%s]\n", Tmp);
	//printf ("%s%s%s%s", Liste_Machines[MachineSelectionner_Nouvelle_Signature].Entete_FTP, Liste_Machines[MachineSelectionner_Nouvelle_Signature].Entete_HTTP, Liste_Machines[MachineSelectionner_Nouvelle_Signature].Entete_IMAP, Liste_Machines[MachineSelectionner_Nouvelle_Signature].Entete_TELNET);
	if (!Modif_Signature) {
		gtk_widget_hide (window_Liste_Signatures);
		gtk_widget_set_sensitive (ctree_Liste_Machine, FALSE);
		EnteteFTP = url_encode (Liste_Machines[MachineSelectionner_Nouvelle_Signature].Entete_FTP);
		EnteteHTTP = url_encode (Liste_Machines[MachineSelectionner_Nouvelle_Signature].Entete_HTTP);
		EnteteIMAP = url_encode (Liste_Machines[MachineSelectionner_Nouvelle_Signature].Entete_IMAP);
		EnteteTELNET = url_encode (Liste_Machines[MachineSelectionner_Nouvelle_Signature].Entete_TELNET);
		DebugSignature = url_encode (Liste_Machines[MachineSelectionner_Nouvelle_Signature].DebugSignature);

		strncpy (Adresse_Mac_Fournisseur, Liste_Machines[MachineSelectionner_Nouvelle_Signature].Adresse_Mac, 8);
		Adresse_Mac_Fournisseur[8] = 0;
		if (Etat_Port (MachineSelectionner_Nouvelle_Signature, 21))
			strcpy (etat_ftp, "OUVERT_FTP");
		else
			strcpy (etat_ftp, "FERMER_FTP");

		if (Etat_Port (MachineSelectionner_Nouvelle_Signature, 80))
			strcpy (etat_http, "OUVERT_HTTP");
		else
			strcpy (etat_http, "FERMER_HTTP");

		if (Etat_Port (MachineSelectionner_Nouvelle_Signature, 143))
			strcpy (etat_imap, "OUVERT_IMAP");
		else
			strcpy (etat_imap, "FERMER_IMAP");

		if (Etat_Port (MachineSelectionner_Nouvelle_Signature, 23))
			strcpy (etat_telnet, "OUVERT_TELNET");
		else
			strcpy (etat_telnet, "FERMER_TELNET");

		if (Etat_Port (MachineSelectionner_Nouvelle_Signature, 515))
			strcpy (etat_spooler, "OUVERT_SPOOLER");
		else
			strcpy (etat_spooler, "FERMER_SPOOLER");

		Envoie_Signature_Html (gtk_entry_get_text (GTK_ENTRY (entry_Liste_Signatures_Nom)), gtk_entry_get_text (GTK_ENTRY (entry_Liste_Signatures_md5)), gtk_entry_get_text (GTK_ENTRY (entry_Liste_Signatures_Type)), Liste_Machines[MachineSelectionner_Nouvelle_Signature].Nb_Port_Ouvert, Adresse_Mac_Fournisseur, etat_ftp, etat_http, etat_imap, etat_telnet, etat_spooler, EnteteFTP, EnteteHTTP, EnteteIMAP, EnteteTELNET, DebugSignature);


		free (EnteteFTP);
		free (EnteteHTTP);
		free (EnteteIMAP);
		free (EnteteTELNET);
		free (DebugSignature);
	}
	/* Redimensionne le tableau */
	if ((Liste_Signature = realloc (Liste_Signature, sizeof (struct struct_Liste_Signature) * (Nb_Signature + 2))) == NULL) {
		debug_printf (D_ERRO, "[I] Realloc erreur\n");
		exit (0);
	}
	/* Ajoute la nouvelle signature dans le tableau */
	Ajoute_Nouvelle_Signature (Tmp, Nb_Signature);
	Nb_Signature++;
	Liste_Signature[Nb_Signature].Nom = FIN;	//FIN   
	/* Affiche la nouvelle entree dans la liste */
	text[0] = g_strdup_printf (Liste_Signature[Nb_Signature - 1].Nom);
	sprintf (Tmp, "%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", Liste_Signature[Nb_Signature - 1].digest[0], Liste_Signature[Nb_Signature - 1].digest[1], Liste_Signature[Nb_Signature - 1].digest[2], Liste_Signature[Nb_Signature - 1].digest[3], Liste_Signature[Nb_Signature - 1].digest[4], Liste_Signature[Nb_Signature - 1].digest[5], Liste_Signature[Nb_Signature - 1].digest[6], Liste_Signature[Nb_Signature - 1].digest[7], Liste_Signature[Nb_Signature - 1].digest[8], Liste_Signature[Nb_Signature - 1].digest[9], Liste_Signature[Nb_Signature - 1].digest[10], Liste_Signature[Nb_Signature - 1].digest[11], Liste_Signature[Nb_Signature - 1].digest[12], Liste_Signature[Nb_Signature - 1].digest[13], Liste_Signature[Nb_Signature - 1].digest[14], Liste_Signature[Nb_Signature - 1].digest[15]);
	text[1] = g_strdup_printf (Tmp);
	//text[1] = g_strdup_printf (Tmp);
	Node = gtk_ctree_insert_node (GTK_CTREE (ctree_Liste_Signatures), NULL, NULL, text, 5, NULL, NULL, NULL, NULL, FALSE, FALSE);
	gtk_ctree_node_set_row_data (GTK_CTREE (ctree_Liste_Signatures), Node, (gpointer *) (Nb_Signature - 1));
	Liste_Signature[Nb_Signature - 1].Node = Node;
	g_free (text[0]);
	g_free (text[1]);
	Init_Info_Signature ();
}

void on_button_Liste_Signatures_Annuler_clicked (GtkButton * button, gpointer user_data)
{
	if (Modif_Signature)
		debug_printf (D_ALL, "[I] Annulation Modification d'une signature %s\n", Liste_Signature[Signature_Selectionner].Nom);
	else
		debug_printf (D_ALL, "[I] Annulation Ajout d'une signature %s\n", gtk_entry_get_text (GTK_ENTRY (entry_Liste_Signatures_Nom)));
	Init_Info_Signature ();
}



void on_ctree_Liste_Signatures_tree_select_row (GtkCTree * ctree, GtkCTreeNode * node, gint column, gpointer user_data)
{
	char      Tmp[100];

	Signature_Selectionner = (int) gtk_ctree_node_get_row_data (GTK_CTREE (ctree), node);
	debug_printf (D_ALL, "[I] Signature : %d\n", Signature_Selectionner);
	Modif_Signature = TRUE;	// permet de ne pas prendre en compte les modifications par la fonction Liste_Script_changed
	gtk_entry_set_text (GTK_ENTRY (entry_Liste_Signatures_Nom), Liste_Signature[Signature_Selectionner].Nom);
	sprintf (Tmp, "%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", Liste_Signature[Signature_Selectionner].digest[0], Liste_Signature[Signature_Selectionner].digest[1], Liste_Signature[Signature_Selectionner].digest[2], Liste_Signature[Signature_Selectionner].digest[3], Liste_Signature[Signature_Selectionner].digest[4], Liste_Signature[Signature_Selectionner].digest[5], Liste_Signature[Signature_Selectionner].digest[6], Liste_Signature[Signature_Selectionner].digest[7], Liste_Signature[Signature_Selectionner].digest[8], Liste_Signature[Signature_Selectionner].digest[9], Liste_Signature[Signature_Selectionner].digest[10], Liste_Signature[Signature_Selectionner].digest[11], Liste_Signature[Signature_Selectionner].digest[12], Liste_Signature[Signature_Selectionner].digest[13], Liste_Signature[Signature_Selectionner].digest[14], Liste_Signature[Signature_Selectionner].digest[15]);
	gtk_entry_set_text (GTK_ENTRY (entry_Liste_Signatures_md5), Tmp);

	gtk_entry_set_text (GTK_ENTRY (entry_Liste_Signatures_Etat_Action_Email), Liste_Signature[Signature_Selectionner].Email);
	if (Liste_Signature[Signature_Selectionner].Requete_Netbios == 0)
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Signatures_NETBIOS), FALSE);
	else
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Signatures_NETBIOS), TRUE);

	if (Liste_Signature[Signature_Selectionner].Routeur == 0)
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Signatures_Routeur), FALSE);
	else
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Signatures_Routeur), TRUE);

	if (Liste_Signature[Signature_Selectionner].Etat_Equipement == 0)
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Signatures_Etat), FALSE);
	else
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Signatures_Etat), TRUE);

	if (Liste_Signature[Signature_Selectionner].Etat_Equipement_Eteint == 0)
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Signatures_Etat_Down), FALSE);
	else
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Signatures_Etat_Down), TRUE);

	if (Liste_Signature[Signature_Selectionner].Etat_Equipement_Message == 0)
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Signatures_Etat_Action_Message), FALSE);
	else
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Signatures_Etat_Action_Message), TRUE);

	if (Liste_Signature[Signature_Selectionner].Etat_Equipement_Email == 0)
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Signatures_Etat_Action_Email), FALSE);
	else
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Signatures_Etat_Action_Email), TRUE);

	if (strlen (Liste_Signature[Signature_Selectionner].Fichier_Icone) == 0) {
		debug_printf (D_WARN, "[I] Pas Icone\n");
		gnome_icon_entry_set_filename (iconentry_Liste_Signature_Allumer, NULL);
	}
	else {
		if (!gnome_icon_entry_set_filename (iconentry_Liste_Signature_Allumer, Liste_Signature[Signature_Selectionner].Fichier_Icone))
			debug_printf (D_WARN, "[I] Icone %s non charger\n", Liste_Signature[Signature_Selectionner].Fichier_Icone);
	}

	if (strlen (Liste_Signature[Signature_Selectionner].Fichier_Icone_Eteint) == 0) {
		debug_printf (D_WARN, "[I] Pas Icone Eteint\n");
		gnome_icon_entry_set_filename (iconentry_Liste_Signature_Eteint, NULL);
	}
	else {
		if (!gnome_icon_entry_set_filename (iconentry_Liste_Signature_Eteint, Liste_Signature[Signature_Selectionner].Fichier_Icone_Eteint))
			debug_printf (D_WARN, "[I] Icone eteint %s non charger\n", Liste_Signature[Signature_Selectionner].Fichier_Icone_Eteint);
	}
	switch (Liste_Signature[Signature_Selectionner].Type_Machine) {
	    case SERVEUR:
		    gtk_entry_set_text (GTK_ENTRY (entry_Liste_Signatures_Type), "Server");
		    break;
	    case STATION:
		    gtk_entry_set_text (GTK_ENTRY (entry_Liste_Signatures_Type), "WorkStation");
		    break;
	    case SWITCH:
		    gtk_entry_set_text (GTK_ENTRY (entry_Liste_Signatures_Type), "Switch");
		    break;
	    case IMPRIMANTE:
		    gtk_entry_set_text (GTK_ENTRY (entry_Liste_Signatures_Type), "Printer");
		    break;
	    case AUTRE:
		    gtk_entry_set_text (GTK_ENTRY (entry_Liste_Signatures_Type), "Other");
		    break;
	    case ROUTEUR:
		    gtk_entry_set_text (GTK_ENTRY (entry_Liste_Signatures_Type), "Router");
		    break;
	    case ROUTEUR_SWITCH:
		    gtk_entry_set_text (GTK_ENTRY (entry_Liste_Signatures_Type), "Router-Switch");
		    break;
	    case POINT_ACCESS_WIFI:
		    gtk_entry_set_text (GTK_ENTRY (entry_Liste_Signatures_Type), "Wifi");
		    break;
	    default:
		    gtk_entry_set_text (GTK_ENTRY (entry_Liste_Signatures_Type), "???");
	}
	gtk_widget_set_sensitive (button_Liste_Signatures_Ajouter, TRUE);
	gtk_widget_set_sensitive (button_Liste_Signatures_Enlever, TRUE);
	gtk_widget_set_sensitive (button_Liste_Signatures_Ok, FALSE);
	gtk_widget_set_sensitive (button_Liste_Signatures_Annuler, FALSE);
	gtk_widget_set_sensitive (button_Liste_Signatures_Sauvegarder, TRUE);
	gtk_widget_set_sensitive (entry_Liste_Signatures_Nom, TRUE);
	gtk_widget_set_sensitive (entry_Liste_Signatures_md5, TRUE);
	gtk_widget_set_sensitive (iconentry_Liste_Signature_Allumer, TRUE);
	gtk_widget_set_sensitive (iconentry_Liste_Signature_Eteint, TRUE);
	gtk_widget_set_sensitive (combo_Liste_Signatures_Type, TRUE);
	gtk_widget_set_sensitive (checkbutton_Liste_Signatures_Routeur, TRUE);
	gtk_widget_set_sensitive (checkbutton_Liste_Signatures_NETBIOS, TRUE);
	gtk_widget_set_sensitive (checkbutton_Liste_Signatures_Etat, FALSE);	//<<<<<<<<<<<<<<<<<<<<<<<
	Modif_Signature = FALSE;
	Change_Etat_Signature ();
}


void Liste_Signatures_changed (GtkEditable * editable, gpointer user_data)
{
	if ((!Modif_Signature) && (!Ajout_Signature)) {
		gtk_widget_set_sensitive (button_Liste_Signatures_Ajouter, FALSE);
		gtk_widget_set_sensitive (button_Liste_Signatures_Enlever, FALSE);
		gtk_widget_set_sensitive (button_Liste_Signatures_Sauvegarder, FALSE);
		gtk_widget_set_sensitive (button_Liste_Signatures_Annuler, TRUE);
		gtk_widget_set_sensitive (button_Liste_Signatures_Ok, TRUE);
		gtk_widget_set_sensitive (ctree_Liste_Signatures, FALSE);
		Modif_Signature = TRUE;
		debug_printf (D_ALL, "[I] Modifie le Signature %s\n", Liste_Signature[Signature_Selectionner].Nom);
	}
}


void on_button_Liste_Signatures_Sauvegarder_clicked (GtkButton * button, gpointer user_data)
{
	FILE     *Fichier_SignatureList;
	char      buf[512], CheminFichier[255];
	int       i;
	struct struct_Demande Demande_Relire_Fichier_Liste_Signature;


	/* Enregistrement de la liste des scripts */
	sprintf (CheminFichier, "%s/.AutoScan/Conf/FingerPrinting", Info_User->pw_dir);
	if ((Fichier_SignatureList = fopen (CheminFichier, "w")) == NULL) {
		perror ("[I] fopen :");
		debug_printf (D_ERRO, "[I] Impossible de ecrire SignatureListe\n");
		exit (-1);
	}
	for (i = 0; i < Nb_Signature; i++) {
		if (Liste_Signature[i].Nom != EFFACER) {
			sprintf (buf, "%s;%d;%d;%d;%d;%d;%d;%d;%s;%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X;%s;%s;\n", Liste_Signature[i].Nom, Liste_Signature[i].Type_Machine, Liste_Signature[i].Requete_Netbios, Liste_Signature[i].Routeur, Liste_Signature[i].Etat_Equipement, Liste_Signature[i].Etat_Equipement_Eteint, Liste_Signature[i].Etat_Equipement_Message, Liste_Signature[i].Etat_Equipement_Email, Liste_Signature[i].Email, Liste_Signature[i].digest[0], Liste_Signature[i].digest[1], Liste_Signature[i].digest[2], Liste_Signature[i].digest[3], Liste_Signature[i].digest[4], Liste_Signature[i].digest[5], Liste_Signature[i].digest[6], Liste_Signature[i].digest[7], Liste_Signature[i].digest[8], Liste_Signature[i].digest[9], Liste_Signature[i].digest[10], Liste_Signature[i].digest[11], Liste_Signature[i].digest[12], Liste_Signature[i].digest[13], Liste_Signature[i].digest[14], Liste_Signature[i].digest[15], Liste_Signature[i].Fichier_Icone, Liste_Signature[i].Fichier_Icone_Eteint);
			debug_printf (D_ALL, "test : [%s]\n", buf);
			/* Enregistrement */
			if (fputs (buf, Fichier_SignatureList) != 1)
				debug_printf (D_ERRO, "[I] Erreur Ecriture fichier SignatureListe\n");
		}
	}
	fclose (Fichier_SignatureList);
	/* Libere la liste des signatures (A finir tout n'est pas libérer !!!) */
	free (Liste_Signature);
	/* Créer une nouvelle liste avec le contenu du fichier */
	Creer_SignatureList ();
	/* Demande a autoscan_d de relire la liste des signatures */
	Demande_Relire_Fichier_Liste_Signature.type = 1;
	Demande_Relire_Fichier_Liste_Signature.type_demande = RELECTURE_FICHIER_CONFIGURATION;
	strcpy (Demande_Relire_Fichier_Liste_Signature.donnee, "");
	if (msgsnd (File_Envoie_Demande, (void *) &Demande_Relire_Fichier_Liste_Signature, sizeof (Demande_Relire_Fichier_Liste_Signature) - sizeof (long), 0) < 0) {
		perror ("[I] msgsnd");
		exit (1);
	}
	gtk_widget_hide (window_Liste_Signatures);
}

GtkCTreeNode *Ajoute_Imprimante (int Machine)
{
	gchar    *text[1];
	char      Tmp[20];
	GtkCTreeNode *Node_Parent;


	Node_Parent = NULL;
	if (Liste_Machines[Machine].TypeMateriel == IMPRIMANTE) {
		if (Node_Imprimante == NULL) {
			text[0] = g_strdup_printf ("Printer");
			Node_Imprimante = gtk_ctree_insert_node (GTK_CTREE (ctree_Liste_Machine), NULL, NULL, text, 5, Pixmap_Imprimante, Masque_Imprimante, Pixmap_Imprimante, Masque_Imprimante, FALSE, FALSE);
			gtk_ctree_node_set_row_data (GTK_CTREE (ctree_Liste_Machine), Node_Imprimante, (gpointer *) IMPRIMANTE);
			g_free (text[0]);
		}
		Node_Parent = Node_Imprimante;
	}
	return Node_Parent;
}


GtkCTreeNode *Ajoute_Routeur_Switch (int Machine)
{
	gchar    *text[1];
	char      Tmp[20];
	GtkCTreeNode *Node_Parent;


	Node_Parent = NULL;
	if (Liste_Machines[Machine].TypeMateriel == ROUTEUR_SWITCH) {
		if (Node_Routeur_Switch == NULL) {
			text[0] = g_strdup_printf ("Router-Switch");
			Node_Routeur_Switch = gtk_ctree_insert_node (GTK_CTREE (ctree_Liste_Machine), NULL, NULL, text, 5, Pixmap_Routeur_Switch, Masque_Routeur_Switch, Pixmap_Routeur_Switch, Masque_Routeur_Switch, FALSE, FALSE);
			gtk_ctree_node_set_row_data (GTK_CTREE (ctree_Liste_Machine), Node_Routeur_Switch, (gpointer *) ROUTEUR_SWITCH);
			g_free (text[0]);
		}
		Node_Parent = Node_Routeur_Switch;
	}
	return Node_Parent;
}


GtkCTreeNode *Ajoute_Routeur (int Machine)
{
	gchar    *text[1];
	char      Tmp[20];
	GtkCTreeNode *Node_Parent;


	Node_Parent = NULL;
	if (Liste_Machines[Machine].TypeMateriel == ROUTEUR) {
		if (Node_Routeur == NULL) {
			text[0] = g_strdup_printf ("Router");
			Node_Routeur = gtk_ctree_insert_node (GTK_CTREE (ctree_Liste_Machine), NULL, NULL, text, 5, Pixmap_Routeur, Masque_Routeur, Pixmap_Routeur, Masque_Routeur, FALSE, FALSE);
			gtk_ctree_node_set_row_data (GTK_CTREE (ctree_Liste_Machine), Node_Routeur, (gpointer *) ROUTEUR);
			g_free (text[0]);
		}
		Node_Parent = Node_Routeur;
	}
	return Node_Parent;
}



GtkCTreeNode *Ajoute_Switch (int Machine)
{
	gchar    *text[1];
	char      Tmp[20];
	GtkCTreeNode *Node_Parent;


	Node_Parent = NULL;
	if (Liste_Machines[Machine].TypeMateriel == SWITCH) {
		if (Node_Switch == NULL) {
			text[0] = g_strdup_printf ("Switch");
			Node_Switch = gtk_ctree_insert_node (GTK_CTREE (ctree_Liste_Machine), NULL, NULL, text, 5, Pixmap_Switch, Masque_Switch, Pixmap_Switch, Masque_Switch, FALSE, FALSE);
			gtk_ctree_node_set_row_data (GTK_CTREE (ctree_Liste_Machine), Node_Switch, (gpointer *) SWITCH);
			g_free (text[0]);
		}
		Node_Parent = Node_Switch;
	}
	return Node_Parent;
}


GtkCTreeNode *Ajoute_Point_Access_Wifi (int Machine)
{
	gchar    *text[1];
	char      Tmp[20];
	GtkCTreeNode *Node_Parent;

	Node_Parent = NULL;
	if (Liste_Machines[Machine].TypeMateriel == POINT_ACCESS_WIFI) {
		if (Node_Wifi == NULL) {
			text[0] = g_strdup_printf ("Wifi");
			Node_Wifi = gtk_ctree_insert_node (GTK_CTREE (ctree_Liste_Machine), NULL, NULL, text, 5, Pixmap_Wifi, Masque_Wifi, Pixmap_Wifi, Masque_Wifi, FALSE, FALSE);
			gtk_ctree_node_set_row_data (GTK_CTREE (ctree_Liste_Machine), Node_Wifi, (gpointer *) POINT_ACCESS_WIFI);
			g_free (text[0]);
		}
		Node_Parent = Node_Wifi;
	}
	return Node_Parent;
}

void Identifie_Machine (int Machine)
{
	int       i;

	for (i = 0; i < Nb_Signature; i++) {
		if (memcmp (Liste_Signature[i].digest, Liste_Machines[Machine].digest, 16) == 0) {
			Liste_Machines[Machine].TypeMateriel = Liste_Signature[i].Type_Machine;
			Liste_Machines[Machine].Masque = Liste_Signature[i].Masque;
			Liste_Machines[Machine].Image = Liste_Signature[i].Image;
			Liste_Machines[Machine].Masque_Eteint = Liste_Signature[i].Masque_Eteint;
			Liste_Machines[Machine].Image_Eteint = Liste_Signature[i].Image_Eteint;
			debug_printf (D_ALL, "[I] signature OK : %s  Type : %d\n", Liste_Machines[Machine].Adresse_Ip, Liste_Machines[Machine].TypeMateriel);
			continue;
		}
	}
	if (Liste_Machines[Machine].TypeMateriel == INCONNU)
		debug_printf (D_ALL, "[I] Aucune signature trouve pour la machine %d\n", i, Machine);
}
