/*
 *  Copyright (C) 2004 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>
#include <signal.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <libgnomevfs/gnome-vfs.h>
#include <wchar.h>
#include "interface.h"
#include "support.h"
#include "Reseau.h"
#include "callbacks.h"
#include "Commun.h"
#include "Machine.h"
#include "Debug.h"

GThreadFunctions *vtable;
static int ptimer_Rafraichi = 0;
extern int h_errno;

static const char version[] = "AutoScan 0.95: compilé le " __TIME__ " " __DATE__ " pid(%d)\n";



int       Num_Machine = 0;
int       Nb_thread_Scan = 0;
gboolean  refresh, Script_Retour;
int       Afficher_Fenetre_Image_Demarrage;
gboolean  Affiche_Image;



gboolean timer ()
{
	struct struct_Machines_Resultat Resultat;
	struct struct_Message Message_Envoyer;
	struct struct_Message_Temps_Reel Message_Envoyer_Temps_Reel;
	int       Taille_Recuperer, i, Machine, Nb_Machine_Recuperer, Taille_Recuperer_Message, Taille_Recuperer_Message_Temps_Reel, Pourcentage;
	gboolean  NouvelleMachine, Modification_Liste_Machine;
	char      temp[255];
	gdouble   Total, A_Faire;
	gchar    *titre[1];
	struct struct_Nessus *Nessus_Info_Creation;

	if (Affiche_Image)
		if (Afficher_Fenetre_Image_Demarrage < 2) {
			//printf("[I] + une seconde\n");
			Afficher_Fenetre_Image_Demarrage++;
		}
		else {
			//printf ("[I] Cache fenetre image demarrage\n");
			Cache_Icone_Demarrage ();
			Affiche_Image = FALSE;
		}

	Nb_Machine_Recuperer = 0;
	Modification_Liste_Machine = FALSE;
	do {
		if ((Taille_Recuperer_Message_Temps_Reel = msgrcv (File_Envoie_Message_Temps_Reel, (void *) &Message_Envoyer_Temps_Reel, sizeof (Message_Envoyer_Temps_Reel) - sizeof (long), 0, IPC_NOWAIT)) > -1) {
			switch (Message_Envoyer_Temps_Reel.type_message) {
			    case ARRET_MACHINE:
				    i = 0;
				    debug_printf (D_ALL,"[I] %02X:%02X:%02X:%02X:%02X:%02X\n", Message_Envoyer_Temps_Reel.Mac_Adresse_Machine[0], Message_Envoyer_Temps_Reel.Mac_Adresse_Machine[1], Message_Envoyer_Temps_Reel.Mac_Adresse_Machine[2], Message_Envoyer_Temps_Reel.Mac_Adresse_Machine[3], Message_Envoyer_Temps_Reel.Mac_Adresse_Machine[4], Message_Envoyer_Temps_Reel.Mac_Adresse_Machine[5]);
				    while ((i < Nb_Machine_Trouve) && (memcmp (&Message_Envoyer_Temps_Reel.Mac_Adresse_Machine, &Liste_Machines[i].AdresseMAC, 6) != 0)) {
					    i++;
				    }
				    debug_printf (D_ALL,"[I] %02X:%02X:%02X:%02X:%02X:%02X   trouvé %d\n", Liste_Machines[i].AdresseMAC[0], Liste_Machines[i].AdresseMAC[1], Liste_Machines[i].AdresseMAC[2], Liste_Machines[i].AdresseMAC[3], Liste_Machines[i].AdresseMAC[4], Liste_Machines[i].AdresseMAC[5], Nb_Machine_Trouve);

				    if (memcmp (&Message_Envoyer_Temps_Reel.Mac_Adresse_Machine, &Liste_Machines[i].AdresseMAC, 6) == 0) {
					    debug_printf (D_ALL,"[I]   Arret machine [%d]  [%s]\n", i, Liste_Machines[i].Adresse_Mac);
					    /* gtk_ctree_node_set_pixmap (GTK_CTREE (ctree_Liste_Machine), Liste_Machines[i].ctree, 0, Liste_Machines[i].Image_Eteint, Liste_Machines[i].Masque_Eteint);
					     * if (Liste_Machines[i].Smb.HostName[0] == 0)
					     * titre[0] = g_strdup_printf (Liste_Machines[i].Adresse_Ip);
					     * else
					     * titre[0] = g_strdup_printf (Liste_Machines[i].Smb.HostName);
					     * gtk_ctree_node_set_text (GTK_CTREE (ctree_Liste_Machine), Liste_Machines[i].ctree, 0, titre);
					     * g_free (titre[0]); */
					    if (!Modification_Liste_Machine) {
						    Modification_Liste_Machine = TRUE;
						    gtk_clist_freeze (GTK_CLIST (ctree_Liste_Machine));	// gel l'affichage
					    }
					    Affiche_Nouvelle_Machine (i, FALSE, FALSE);
					    if (i == MachineSelectionner) {
						    if (Mode_Nessus) {
							    Init_Icon_List ();
							    Mode_Liste_Icone_Port = FALSE;
						    }
						    gtk_widget_set_sensitive (ctree_Info, FALSE);
						    gtk_widget_set_sensitive (iconlist, FALSE);
						    gtk_widget_set_sensitive (optionmenu_Liste_Modes, FALSE);
						    gtk_widget_set_sensitive (button_Liste_Modes_Favorite, FALSE);
						    Afficher_Liste_Port_Ouvert ();
					    }
				    }
				    else
					    debug_printf (D_ERRO,"[I]  ###########################  Arret machine inconnu\n");
				    break;
			    case DEMARRAGE_MACHINE:
				    i = 0;
				    debug_printf (D_ALL,"[I] %02X:%02X:%02X:%02X:%02X:%02X\n", Message_Envoyer_Temps_Reel.Mac_Adresse_Machine[0], Message_Envoyer_Temps_Reel.Mac_Adresse_Machine[1], Message_Envoyer_Temps_Reel.Mac_Adresse_Machine[2], Message_Envoyer_Temps_Reel.Mac_Adresse_Machine[3], Message_Envoyer_Temps_Reel.Mac_Adresse_Machine[4], Message_Envoyer_Temps_Reel.Mac_Adresse_Machine[5]);
				    while ((i < Nb_Machine_Trouve) && (memcmp (&Message_Envoyer_Temps_Reel.Mac_Adresse_Machine, &Liste_Machines[i].AdresseMAC, 6) != 0)) {
					    i++;
					    //printf ("+\n");
				    }
				    debug_printf (D_ALL,"[I] %02X:%02X:%02X:%02X:%02X:%02X   trouvé %d\n", Liste_Machines[i].AdresseMAC[0], Liste_Machines[i].AdresseMAC[1], Liste_Machines[i].AdresseMAC[2], Liste_Machines[i].AdresseMAC[3], Liste_Machines[i].AdresseMAC[4], Liste_Machines[i].AdresseMAC[5], Nb_Machine_Trouve);
				    if (memcmp (&Message_Envoyer_Temps_Reel.Mac_Adresse_Machine, &Liste_Machines[i].AdresseMAC, 6) == 0) {
					    debug_printf (D_ALL,"[I]   Demmarage machine [%d]  [%s]\n", i, Liste_Machines[i].Adresse_Mac);
					    /*gtk_ctree_node_set_pixmap (GTK_CTREE (ctree_Liste_Machine), Liste_Machines[i].ctree, 0, Liste_Machines[i].Image, Liste_Machines[i].Masque);
					     * if (Liste_Machines[i].Smb.HostName[0] == 0)
					     * titre[0] = g_strdup_printf (Liste_Machines[i].Adresse_Ip);
					     * else
					     * titre[0] = g_strdup_printf (Liste_Machines[i].Smb.HostName);
					     * gtk_ctree_node_set_text (GTK_CTREE (ctree_Liste_Machine), Liste_Machines[i].ctree, 0, titre);
					     * g_free (titre[0]); */
					    if (!Modification_Liste_Machine) {
						    Modification_Liste_Machine = TRUE;
						    gtk_clist_freeze (GTK_CLIST (ctree_Liste_Machine));	// gel l'affichage
					    }
					    Affiche_Nouvelle_Machine (i, FALSE, TRUE);
					    if (i == MachineSelectionner) {
						    debug_printf (D_ALL,"[I] Machine Refresh\n");
						    if (Mode_Nessus) {
							    Init_Icon_List ();
							    Mode_Liste_Icone_Port = FALSE;
						    }
						    gtk_widget_set_sensitive (ctree_Info, TRUE);
						    gtk_widget_set_sensitive (iconlist, TRUE);
						    gtk_widget_set_sensitive (optionmenu_Liste_Modes, TRUE);
						    gtk_widget_set_sensitive (button_Liste_Modes_Favorite, TRUE);
						    Afficher_Liste_Port_Ouvert ();
					    }


				    }
				    else
					    debug_printf (D_ERRO,"[I]  ###########################  Demarrage machine inconnu\n");
				    break;
			    case MISE_A_JOUR_UTILISATION_RESEAU:
//                                  printf ("[I] Octet_Envoyer=[%d]   Octet_Recu=[%d]\n", Message_Envoyer_Temps_Reel.Octet_Envoyer, Message_Envoyer_Temps_Reel.Octet_Recu);
				    sprintf (temp, "R : %.1fko", (((double) Message_Envoyer_Temps_Reel.Octet_Recu) / 1024));
				    gtk_label_set_text (Reception_Info, temp);
				    sprintf (temp, "S : %.1fko", (((double) Message_Envoyer_Temps_Reel.Octet_Envoyer) / 1024));
				    gtk_label_set_text (Emission_Info, temp);

				    break;
			    default:
				    debug_printf (D_ERRO,"[I] ################ Type de message inconnu  (Message_Envoyer_Temps_Reel)\n");
			}

		}
		if ((Taille_Recuperer_Message = msgrcv (File_Envoie_Message, (void *) &Message_Envoyer, sizeof (Message_Envoyer) - sizeof (long), 0, IPC_NOWAIT)) > -1) {
			switch (Message_Envoyer.type_message) {
			    case ERREUR:
				    Message (Message_Envoyer.donnee, GNOME_MESSAGE_BOX_ERROR);
				    break;
			    case WARNING:
				    Message (Message_Envoyer.donnee, GNOME_MESSAGE_BOX_WARNING);
				    break;
			    case INFO:
				    Message (Message_Envoyer.donnee, GNOME_MESSAGE_BOX_INFO);
				    break;
			    case RETOUR_SCRIPT:
				    if (!Script_Retour)
					    gtk_widget_show (window_Resultat_Script);
				    gtk_text_insert (GTK_EDITABLE (textview_Resultat_Script), NULL, NULL, NULL, Message_Envoyer.donnee, strlen (Message_Envoyer.donnee));
				    Script_Retour = TRUE;
				    break;
			    case RETOUR_SCRIPT_TERMINE:
				    gtk_text_insert (GTK_EDITABLE (textview_Resultat_Script), NULL, NULL, NULL, "\n************************************\n\n\n", 40);
				    Script_Retour = FALSE;
				    break;
			    case RETOUR_INFO:
				    if (Message_Envoyer.Nb_Machine_Dans_La_Liste != 0) {
					    Total = Message_Envoyer.Nb_Machine_Dans_La_Liste;
					    A_Faire = Message_Envoyer.Nb_Machine_En_Cours_De_Scan + Message_Envoyer.Nb_Machine_En_Attente_De_Scan;
					    gtk_progress_bar_set_fraction (GTK_PROGRESS_BAR (progressbar_Info), (Total - A_Faire) / Total);
					    sprintf (temp, "Total : %d (%d/%d)   %%%d", Message_Envoyer.Nb_Machine_Dans_La_Liste, Message_Envoyer.Nb_Machine_En_Cours_De_Scan, Message_Envoyer.Nb_Machine_En_Attente_De_Scan, (int) (((Total - A_Faire) / Total) * 100));
					    gtk_progress_bar_set_text (GTK_PROGRESS_BAR (progressbar_Info), temp);
				    }
				    else {
					    gtk_progress_bar_set_fraction (GTK_PROGRESS_BAR (progressbar_Info), 0);
					    gtk_progress_bar_set_text (GTK_PROGRESS_BAR (progressbar_Info), "Total : 0 (0/0)   %0");
				    }

				    break;
			    case AUTOSCAN_SEGMENTATION_FAULT:
				    Bug_autoscan_d = TRUE;
				    debug_printf (D_ERRO,"[I] autoscan_d a plante\n");
				    break;
			    case RETOUR_NESSUS_TYPE:
				    i = 0;
				    while ((i < Nb_Machine_Trouve) && (strcmp (Message_Envoyer.Adresse_Ip, Liste_Machines[i].Adresse_Ip) != 0)) {
					    i++;
				    }
				    debug_printf (D_ALL,"[I] Nessus TYPE (%s)(%d) =[%s]  (%d)\n", Message_Envoyer.Adresse_Ip, i, Message_Envoyer.donnee, strlen (Message_Envoyer.donnee));
				    if (Liste_Machines[i].Nessus_Info_Debut == NULL) {
					    Liste_Machines[i].Nessus_Info_En_Cours = (struct struct_Nessus *) malloc (sizeof (struct struct_Nessus));
					    Liste_Machines[i].Nessus_Info_Debut = Liste_Machines[i].Nessus_Info_En_Cours;
					    Liste_Machines[i].Nessus_Info_Debut->Type = malloc (sizeof (char) * strlen (Message_Envoyer.donnee));
					    strcpy (Liste_Machines[i].Nessus_Info_Debut->Type, Message_Envoyer.donnee);
					    debug_printf (D_ALL,"[I]  TYPE D: [%s]\n", Liste_Machines[i].Nessus_Info_Debut->Type);
					    debug_printf (D_ALL,"[I]  TYPE E: [%s]\n", Liste_Machines[i].Nessus_Info_En_Cours->Type);
				    }
				    else {
					    debug_printf (D_ALL,"[I]  INFO malloc\n");
					    Nessus_Info_Creation = (struct struct_Nessus *) malloc (sizeof (struct struct_Nessus));
					    debug_printf (D_ALL,"[I]  INFO malloc (%i)\n", Nessus_Info_Creation);
					    Liste_Machines[i].Nessus_Info_En_Cours->Nessus_Suivant = Nessus_Info_Creation;
					    Liste_Machines[i].Nessus_Info_En_Cours = Nessus_Info_Creation;
					    Liste_Machines[i].Nessus_Info_En_Cours->Type = malloc ((sizeof (char) * strlen (Message_Envoyer.donnee)) + 1);
					    debug_printf (D_ALL,"[I]       TYPE pointeur : (%i)\n", Liste_Machines[i].Nessus_Info_En_Cours->Type);
					    strcpy (Liste_Machines[i].Nessus_Info_En_Cours->Type, Message_Envoyer.donnee);
					    debug_printf (D_ALL,"[I]  TYPE E: [%s]\n", Liste_Machines[i].Nessus_Info_En_Cours->Type);
				    }
				    Liste_Machines[i].Nessus_Info_En_Cours->Nessus_Suivant = NULL;	// signal la fin de la liste
				    break;
			    case RETOUR_NESSUS_INFO:
				    i = 0;
				    while ((i < Nb_Machine_Trouve) && (strcmp (Message_Envoyer.Adresse_Ip, Liste_Machines[i].Adresse_Ip) != 0)) {
					    i++;
				    }
				    debug_printf (D_ALL,"[I] Nessus INFO (%s) =[%s]  (%d)\n", Message_Envoyer.Adresse_Ip, Message_Envoyer.donnee, strlen (Message_Envoyer.donnee));
				    Liste_Machines[i].Nessus_Info_En_Cours->Info = malloc ((sizeof (char) * strlen (Message_Envoyer.donnee)) + 1);
				    debug_printf (D_ALL,"[I]       TYPE pointeur : (%i)\n", Liste_Machines[i].Nessus_Info_En_Cours->Info);
				    strcpy (Liste_Machines[i].Nessus_Info_En_Cours->Info, Message_Envoyer.donnee);
				    debug_printf (D_ALL,"[I]  INFO E: [%s]\n", Liste_Machines[i].Nessus_Info_En_Cours->Info);
				    break;
			    case RETOUR_NESSUS_DONNEE:
				    debug_printf (D_ALL,"[I] Nessus DONNEE(%d) (%s) =[%s]\n", Message_Envoyer.Taille_Message, Message_Envoyer.Adresse_Ip, Message_Envoyer.donnee);
				    Liste_Machines[i].Nessus_Info_En_Cours->Donnee = malloc ((sizeof (char) * Message_Envoyer.Taille_Message) + 1);
				    if (Message_Envoyer.Taille_Message <= 255) {
					    debug_printf (D_ALL,"Ajoute %d caracteres\n", Message_Envoyer.Taille_Message);
					    strncpy (Liste_Machines[i].Nessus_Info_En_Cours->Donnee, Message_Envoyer.donnee, Message_Envoyer.Taille_Message);
					    Liste_Machines[i].Nessus_Info_En_Cours->Donnee[Message_Envoyer.Taille_Message] = 0;
					    debug_printf (D_ALL,"OK\n");
				    }
				    else {
					    debug_printf (D_ALL,"Ajoute 255 caracteres\n");
					    strncpy (Liste_Machines[i].Nessus_Info_En_Cours->Donnee, Message_Envoyer.donnee, 255);
					    debug_printf (D_ALL,"OK\n");
				    }

				    break;
			    case RETOUR_NESSUS_DONNEE_SUITE:
				    i = 0;
				    while ((i < Nb_Machine_Trouve) && (strcmp (Message_Envoyer.Adresse_Ip, Liste_Machines[i].Adresse_Ip) != 0)) {
					    i++;
				    }
				    debug_printf (D_ALL,"[I] Nessus DONNEE_SUITE (%s)(%d) =[%s]\n", Message_Envoyer.Adresse_Ip, Message_Envoyer.Taille_Message, Message_Envoyer.donnee);
				    Liste_Machines[i].Nessus_Info_En_Cours->Donnee[Message_Envoyer.Index_Chaine] = 0;
				    strncat (Liste_Machines[i].Nessus_Info_En_Cours->Donnee, Message_Envoyer.donnee, Message_Envoyer.Taille_Message);
				    if (Message_Envoyer.Taille_Message < 255) {
					    Liste_Machines[i].Nessus_Info_En_Cours->Donnee[Message_Envoyer.Index_Chaine + Message_Envoyer.Taille_Message] = 0;
					    debug_printf (D_ALL,"\n\n\n[I]   TOTAL [%s]\n\n\n\n", Liste_Machines[i].Nessus_Info_En_Cours->Donnee);
				    }
				    break;
			    case RETOUR_NESSUS_FIN:
				    debug_printf (D_ALL,"[I] Nessus Fin\n");
				    i = 0;
				    while ((i < Nb_Machine_Trouve) && (strcmp (Message_Envoyer.Adresse_Ip, Liste_Machines[i].Adresse_Ip) != 0)) {
					    i++;
				    }
				    /*printf("[I] Nessus_Info_Debut(%i)\n",Liste_Machines[i].Nessus_Info_Debut);
				     * printf ("[I]  TYPE D: [%i]\n", Liste_Machines[i].Nessus_Info_Debut->Type);
				     * printf("[I]       TYPE pointeur : (%i)\n",Liste_Machines[i].Nessus_Info_Debut->Info); */
				    Affiche_Liste_Vulnerabilite (i);
				    creation_Liste_Index (i);
				    break;
			    default:
				    debug_printf (D_ERRO,"[I] ################ Type de message inconnu (Message_Envoyer)\n");
			}
		}

		if ((Taille_Recuperer = msgrcv (File_Reception_Nouvelle_Machine, (void *) &Resultat, sizeof (Resultat) - sizeof (long), 0, IPC_NOWAIT)) > -1) {
			debug_printf (D_ALL,"[I] Reception nouvelle machine ou resultat rescan machine   %d=%d  %d\n", Taille_Recuperer, (sizeof (Resultat) - sizeof (long)), sizeof (gboolean));
			if (Taille_Recuperer == (sizeof (Resultat) - sizeof (long))) {
				if (!Modification_Liste_Machine) {
					Modification_Liste_Machine = TRUE;
					gtk_clist_freeze (GTK_CLIST (ctree_Liste_Machine));	// gel l'affichage
				}
				/* Est que c'est une nouvelle machine ou juste un rescan */
				NouvelleMachine = TRUE;
				i = 0;
				debug_printf (D_ALL,"%04X  %04X\n", Resultat.AdresseIp, Liste_Machines[i].AdresseIp);
				while ((i < Nb_Machine_Trouve) && (memcmp (&Resultat.AdresseIp, &Liste_Machines[i].AdresseIp, 4) != 0)) {
					i++;
				}
				if (memcmp (&Resultat.AdresseIp, &Liste_Machines[i].AdresseIp, 4) == 0) {
					NouvelleMachine = FALSE;	// ce n'est pas une nouvelle machine juste un rescan
					/*free (Liste_Machines[Machine].Entete_FTP);
					 * free (Liste_Machines[Machine].Entete_HTTP);
					 * free (Liste_Machines[Machine].Entete_IMAP);
					 * free (Liste_Machines[Machine].Entete_TELNET); */
				}
				if (NouvelleMachine) {
					Machine = Nb_Machine_Trouve;
					Total = Resultat.Nb_Machine_Dans_La_Liste;
					A_Faire = Resultat.Nb_Machine_En_Cours_De_Scan + Resultat.Nb_Machine_En_Attente_De_Scan;
					debug_printf (D_ALL,"[I] Resultat Nouvelle Machine  %d   --> %g %g   %g\n", Machine, Total, A_Faire, (Total - A_Faire) / Total);
					gtk_progress_bar_set_fraction (GTK_PROGRESS_BAR (progressbar_Info), (Total - A_Faire) / Total);
					sprintf (temp, "Total : %d (%d/%d)   %%%d", Resultat.Nb_Machine_Dans_La_Liste, Resultat.Nb_Machine_En_Cours_De_Scan, Resultat.Nb_Machine_En_Attente_De_Scan, (int) (((Total - A_Faire) / Total) * 100));
					gtk_progress_bar_set_text (GTK_PROGRESS_BAR (progressbar_Info), temp);
				}
				else {
					Machine = i;
					debug_printf (D_ALL,"[I] Resultat rescanne Machine  %d\n", i);
				}
				Initialise_Structure_Machine (Machine);
				Ajoute_Nouvelle_Machine (Machine, Resultat.Adresse_Ip, Resultat.Adresse_Mac, Resultat.AdresseIp, Resultat.AdresseMAC, NouvelleMachine);
				memcpy (Liste_Machines[Machine].digest, Resultat.digest, 16);
				Identifie_Machine (Machine);
				/* Ajout les ports */
				Liste_Machines[Machine].Nb_Port_Ouvert = 0;
				for (i = 0; i < Resultat.Nb_Port_Ouvert; i++)
					Ajoute_port (Machine, Resultat.Port[i].Index_Port, Resultat.Port[i].Etat, Resultat.Port[i].Num_Port, Resultat.Port[i].Type_Machine);
				Liste_Machines[Machine].Nb_Port_Fermer = Resultat.Nb_Port_Fermer;
				Liste_Machines[Machine].Nb_Port_Firewaller = Resultat.Nb_Port_Firewaller;
				Liste_Machines[Machine].Nb_Port_Total_Scanner = Resultat.Nb_Port_Total_Scanner;
				/* Recuperation des entetes */
				Liste_Machines[Machine].Entete_FTP = malloc (sizeof (char) * (strlen (Resultat.Entete_FTP) + 1));
				strcpy (Liste_Machines[Machine].Entete_FTP, Resultat.Entete_FTP);
				Liste_Machines[Machine].Entete_HTTP = malloc (sizeof (char) * (strlen (Resultat.Entete_HTTP) + 1));
				strcpy (Liste_Machines[Machine].Entete_HTTP, Resultat.Entete_HTTP);
				Liste_Machines[Machine].Entete_IMAP = malloc (sizeof (char) * (strlen (Resultat.Entete_IMAP) + 1));
				strcpy (Liste_Machines[Machine].Entete_IMAP, Resultat.Entete_IMAP);
				Liste_Machines[Machine].Entete_TELNET = malloc (sizeof (char) * (strlen (Resultat.Entete_TELNET) + 1));
				strcpy (Liste_Machines[Machine].Entete_TELNET, Resultat.Entete_TELNET);
				strcpy (Liste_Machines[Machine].DebugSignature, Resultat.DebugSignature);

				/* Ajout les infos netbios */
				strcpy (Liste_Machines[Machine].Smb.HostName, Resultat.Smb.HostName);
				strcpy (Liste_Machines[Machine].Smb.DomainName, Resultat.Smb.DomainName);
				strcpy (Liste_Machines[Machine].Smb.Utilisateur, Resultat.Smb.Utilisateur);
				i = 0;
				while (Resultat.Smb.Smb_Registration[i].Type != 0) {
					Liste_Machines[Machine].Smb.Smb_Registration[i].Type = Resultat.Smb.Smb_Registration[i].Type;
					strcpy (Liste_Machines[Machine].Smb.Smb_Registration[i].Name, Resultat.Smb.Smb_Registration[i].Name);
					Liste_Machines[Machine].Smb.Smb_Registration[i].Numero = Resultat.Smb.Smb_Registration[i].Numero;
					i++;
				}
				Liste_Machines[Machine].Serveur = Resultat.Serveur;
				Affiche_Nouvelle_Machine (Machine, NouvelleMachine, TRUE);
				Nb_Machine_Recuperer++;
			}
			else {
				debug_printf (D_ERRO,"[I] Erreur taille de reponse nouvelle machine trouve\n");
				exit (-1);
			}
		}
	} while ((Taille_Recuperer_Message_Temps_Reel != -1) || (Taille_Recuperer_Message != -1) || (Taille_Recuperer != -1));
	if (Modification_Liste_Machine)
		gtk_clist_thaw (GTK_CLIST (ctree_Liste_Machine));

	return TRUE;
}

int Valeur_Semaphore (sem_t * sem)
{
	int       valeur;

	sem_getvalue (sem, &valeur);
	return valeur;
}

void Control_C (int sig)
{
	debug_printf (D_ERRO, "[S] Control_C\n");
	Fin (ARRET_CONTROL_C);
}

void segfault_handler (int sig)
{
	char      erreur[255];


	debug_printf (D_ERRO, "\n[I] Segmentation fault    Et oui. Encore un bug   pid : %d\n", getpid ());
	Fin (ARRET);
}

int main (int argc, char *argv[])
{
	GdkColor  Transparent;
	GdkColor  CouleurFond;
	pid_t     pid_fils;


	Debug = D_INFO;

	debug_printf (D_INFO, version, getpid ());
	debug_printf (D_ALL, "[I] Creation du signal\n");
	signal (SIGSEGV, segfault_handler);
	signal (SIGINT, Control_C);





	gtk_set_locale ();
	gnome_program_init (PACKAGE, VERSION, LIBGNOMEUI_MODULE, argc, argv, GNOME_PARAM_APP_DATADIR, PACKAGE_DATA_DIR, NULL);
	gnome_vfs_init ();	
	client_gconf = gconf_client_get_default ();
	window = create_window ();
	Afficher_Icone_Demarrage ();
	Affiche_Image = TRUE;
	Afficher_Fenetre_Image_Demarrage = 0;
	IconeFocus = -1;

	Demarrage = TRUE;
	Script_Retour = FALSE;
	Bug_autoscan_d = FALSE;
	Info_User = getpwuid (getuid ());
	MachineSelectionner = INCONNU;
	IconeSelectionner = INCONNU;
	Nb_Machine_Trouve = 0;
	Scan_Actif = TRUE;
	Mode_Liste_Icone_Port = TRUE;
	Mode_Liste_Partage = FALSE;
	Mode_Documentation = FALSE;
	Mode_Documentation_Demarrage = FALSE;
	Mode_Nessus = FALSE;
	/* Destruction des files de messages */
	if (msgctl (msgget (KEY_FILE_RECEPTION_NOUVELLE_MACHINE, 0), IPC_RMID, NULL) == 0) {
		debug_printf (D_WARN, "[I] File KEY_FILE_RECEPTION_NOUVELLE_MACHINE detruite\n");
	}
	if (msgctl (msgget (KEY_FILE_DEMANDE, 0), IPC_RMID, NULL) == 0) {
		debug_printf (D_WARN, "[I] File KEY_FILE_DEMANDE detruite\n");
	}
	if (msgctl (msgget (KEY_FILE_MESSAGE, 0), IPC_RMID, NULL) == 0) {
		debug_printf (D_WARN, "[I] File KEY_FILE_MESSAGE detruite\n");
	}
	if (msgctl (msgget (KEY_FILE_MESSAGE_TEMP_REEL, 0), IPC_RMID, NULL) == 0) {
		debug_printf (D_WARN, "[I] File KEY_FILE_MESSAGE_TEMP_REEL detruite\n");
	}
	/* Création des files de messages */
	if ((File_Reception_Nouvelle_Machine = msgget (KEY_FILE_RECEPTION_NOUVELLE_MACHINE, IPC_CREAT | 0777)) == -1) {
		perror ("[I] msgget");
		exit (1);
	}
	if ((File_Envoie_Demande = msgget (KEY_FILE_DEMANDE, IPC_CREAT | 0777)) == -1) {
		perror ("[I] msgget");
		exit (1);
	}
	if ((File_Envoie_Message = msgget (KEY_FILE_MESSAGE, IPC_CREAT | 0777)) == -1) {
		perror ("[I] msgget");
		exit (1);
	}
	if ((File_Envoie_Message_Temps_Reel = msgget (KEY_FILE_MESSAGE_TEMP_REEL, IPC_CREAT | 0777)) == -1) {
		perror ("[I] msgget");
		exit (1);
	}

	/* Interface au démarrage */
	Interface = (char *) malloc (6);
	strncpy (Interface, "eth0", 5);
	/* Lecture de la configuration */
	Copie_Fichier_Configuration ();
	Creer_PortList ();
	Creer_ScriptList ();
	Creer_Liste_Sous_Reseau ();
	Creer_MacListe ();
	Initialise_Structure_Domaine ();
	Init_Liste_Partage_Monter ();
	/* Creation des fenetres */
	debug_printf (D_ALL, "[I] Creation des fenetres\n");
	window_Tester_Smtp = create_window_Tester_Smtp ();
	window_NetSend = create_window_NetSend ();
	window_Pop3 = create_window_Pop3 ();
	window_Liste_Port = create_window_Liste_Port ();
	window_Force_Reseau = create_window_Force_Reseau ();
	window_Ajout_Script = create_window_Ajout_Script ();
	window_Liste_Signatures = create_window_Liste_Signatures ();
	window_Debug_Scan = create_window_Debug_Scan ();
	window_Partage = create_window_Partage ();
	window_Preference = create_window_Preference ();
	Liste_Interface ();
	Lecture_Fichier_Interface ();
	fileselection_Enregistrer = create_fileselection_Enregistrer ();
	window_Resultat_Script = create_window_Resultat_Script ();
	window_Recherche_Machine = create_window_Recherche_Machine ();
	window_demarrage = create_window_demarrage ();
	gtk_widget_set_sensitive (checkbutton_Demarrage_Mise_A_Jour, FALSE);
	window_Contributions = create_window_Contributions ();
	window_Connection_Internet = create_window_Connection_Internet();
	IconeSelectionner_Nouveau = 0;
	Affiche_Liste_Reseau ();

	gtk_widget_realize (window);
	debug_printf (D_ALL, "[I] Creation des fenetres terminees\n");
	Creer_SignatureList ();
	/* Creation des menus */
	create_menu_Port ();
	create_menu_Liste_Machine ();
	create_menu_Applet ();
	//Creer_Menu_Modes ();  creer dans l'interface probl avec message information
	debug_printf (D_ALL, "[I] Creation des Menus termines\n");
	/* Modification des fenetres */
	gtk_ctree_set_expander_style (GTK_CTREE (ctree_Liste_Machine), GTK_CTREE_EXPANDER_CIRCULAR);
	gtk_ctree_set_line_style (GTK_CTREE (ctree_Liste_Machine), GTK_CTREE_LINES_DOTTED);
	gtk_ctree_set_expander_style (GTK_CTREE (ctree_Liste_Machine), GTK_CTREE_EXPANDER_CIRCULAR);
	gtk_ctree_set_line_style (GTK_CTREE (ctree_Ajout_Script), GTK_CTREE_LINES_NONE);
	gtk_ctree_set_line_style (GTK_CTREE (ctree_Liste_Port), GTK_CTREE_LINES_NONE);
	gtk_ctree_set_line_style (GTK_CTREE (ctree_Liste_Signatures), GTK_CTREE_LINES_NONE);
	gtk_ctree_set_line_style (GTK_CTREE (ctree_Preference_Sous_reseau_privee), GTK_CTREE_LINES_NONE);
	gtk_clist_set_row_height (GTK_CLIST (ctree_Liste_Machine), 17);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Demarrage_Ajouter), TRUE);
	CouleurFond.red = 191;
	CouleurFond.green = 191;
	CouleurFond.blue = 191;
	gtk_clist_set_background (GTK_CLIST (ctree_Liste_Machine), 0, &CouleurFond);
	gtk_clist_set_sort_column (GTK_CLIST (ctree_Liste_Machine), 0);	// trie sur la colonne 0
	gtk_clist_set_sort_type (GTK_CLIST (ctree_Liste_Machine), GTK_SORT_ASCENDING);
	gtk_clist_set_auto_sort (GTK_CLIST (ctree_Liste_Machine), TRUE);
	/* Chargement des images utilisees dans la liste des machines et info */
	/* Type */
	Pixmap_Inconnu = gdk_pixmap_create_from_xpm (window->window, &Masque_Inconnu, &Transparent, "/usr/share/pixmaps/AutoScan/Type/Inconnu.png");
	Pixmap_Firewall = gdk_pixmap_create_from_xpm (window->window, &Masque_Firewall, &Transparent, "/usr/share/pixmaps/AutoScan/Type/firewall.png");
	Pixmap_Serveur = gdk_pixmap_create_from_xpm (window->window, &Masque_Serveur, &Transparent, "/usr/share/pixmaps/AutoScan/Type/Serveur.png");
	Pixmap_Station = gdk_pixmap_create_from_xpm (window->window, &Masque_Station, &Transparent, "/usr/share/pixmaps/AutoScan/Type/Station.xpm");
	Pixmap_Domaine = gdk_pixmap_create_from_xpm (window->window, &Masque_Domaine, &Transparent, "/usr/share/pixmaps/AutoScan/Type/Domaine.png");
	Pixmap_Switch = gdk_pixmap_create_from_xpm (window->window, &Masque_Switch, &Transparent, "/usr/share/pixmaps/AutoScan/Type/switch.png");
	Pixmap_Imprimante = gdk_pixmap_create_from_xpm (window->window, &Masque_Imprimante, &Transparent, "/usr/share/pixmaps/AutoScan/Type/printer.png");
	Pixmap_Routeur = gdk_pixmap_create_from_xpm (window->window, &Masque_Routeur, &Transparent, "/usr/share/pixmaps/AutoScan/Type/router.png");
	Pixmap_Routeur_Switch = gdk_pixmap_create_from_xpm (window->window, &Masque_Routeur_Switch, &Transparent, "/usr/share/pixmaps/AutoScan/Type/routerswitch.png");
	Pixmap_Wifi = gdk_pixmap_create_from_xpm (window->window, &Masque_Wifi, &Transparent, "/usr/share/pixmaps/AutoScan/Type/Access_Point.xpm");
	/* Info */
	Pixmap_Hwinfo = gdk_pixmap_create_from_xpm (window->window, &Masque_Hwinfo, &Transparent, "/usr/share/pixmaps/AutoScan/hwinfo.png");
	Pixmap_Info = gdk_pixmap_create_from_xpm (window->window, &Masque_Info, &Transparent, "/usr/share/pixmaps/AutoScan/info.png");
	Pixmap_Utilisateur = gdk_pixmap_create_from_xpm (window->window, &Masque_Utilisateur, &Transparent, "/usr/share/pixmaps/AutoScan/Utilisateur.xpm");
	Pixmap_HostName = gdk_pixmap_create_from_xpm (window->window, &Masque_HostName, &Transparent, "/usr/share/pixmaps/AutoScan/HostName.png");
	Pixmap_Nessus_Error = gdk_pixmap_create_from_xpm (window->window, &Masque_Nessus_Error, &Transparent, "/usr/share/pixmaps/AutoScan/Nessus_Error.png");
	Pixmap_Nessus_Warning = gdk_pixmap_create_from_xpm (window->window, &Masque_Nessus_Warning, &Transparent, "/usr/share/pixmaps/AutoScan/Nessus_warning.png");
	Pixmap_Nessus_Info = gdk_pixmap_create_from_xpm (window->window, &Masque_Nessus_Info, &Transparent, "/usr/share/pixmaps/AutoScan/Nessus_Info.png");
	/* Modes */
	Pixmap_Port_Ouvert = gdk_pixmap_create_from_xpm (window->window, &Masque_Port_Ouvert, &Transparent, "/usr/share/pixmaps/AutoScan/Port_Ouvert.png");


	/* Conf selection icone */
	gnome_icon_entry_set_pixmap_subdir (iconentry_Liste_Signature_Allumer, "/usr/share/pixmaps/AutoScan/Equipment/Up/");
	gnome_icon_entry_set_pixmap_subdir (iconentry_Liste_Signature_Eteint, "/usr/share/pixmaps/AutoScan/Equipment/Down/");
	gnome_icon_entry_set_pixmap_subdir (iconentry_Liste_Port_Ouvert, "/usr/share/pixmaps/AutoScan/Port/Up/");
	gnome_icon_entry_set_pixmap_subdir (iconentry_Liste_Port_Fermer, "/usr/share/pixmaps/AutoScan/Port/Down/");
	/* Creation des l'icone applet */
	creation_applet_icone ();
	Creer_Menu_Script ();
	Init_Documentation ("/usr/share/doc/AutoScan/Intro.html");
	Mode_Documentation = TRUE;
	Mode_Documentation_Demarrage = TRUE;
	/* Lancement du service super utilisateur */
	pid_fils = fork ();	// création d'un fils
	if (pid_fils == 0) {
		/* Fils */
		system ("autoscan_d");
		exit (127);
	}

	init_Samba ();


	/* Timer de rafraichissement */
	ptimer_Rafraichi = gtk_timeout_add (1000, timer, NULL);




	/* Boucle infini GTK */
	gtk_main ();
	return 0;
}
