/*
 *  Copyright (C) 2004 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef         __MACHINE
#define         __MACHINE

#include "Nessus.h"
#define MAX_MACHINE	5000
#define MAX_PORTS  30

struct struct_Machines {
	GtkCTreeNode *ctree;
	GtkCTreeNode *ctree_Parent;
	unsigned char Adresse_Ip[16];
	unsigned long int AdresseIp;
	unsigned char Adresse_Mac[18];
	unsigned char AdresseMAC[6];
	/* Signature */
	md5_byte_t digest[16 + 1];
	char TypeMateriel;	// serveur, station, materiel reseau , inconnu
	GdkBitmap *Masque; // icone du systeme d'exploitation
	GdkPixmap *Image;	
	GdkBitmap *Masque_Eteint; // icone du systeme d'exploitation
	GdkPixmap *Image_Eteint;
	gboolean  Machine_Allumer;
	GdkColor  color;
	/* Samba */
	struct struct_Smb Smb;
	/* Scan ports */
	FILE     *Debug_Scan;
	gboolean  Scan_Port;	// vrai si un scan des ports
	int       Nb_Port_Ouvert;
	int		  Nb_Port_Total_Scanner;
	int		  Nb_Port_Fermer;
	int		  Nb_Port_Firewaller;
	char      *Entete_FTP;
	char      *Entete_HTTP;
	char      *Entete_IMAP;
	char      *Entete_TELNET;
	char 	  DebugSignature[526];
	gboolean  Serveur;
	struct struct_Ports Port[MAX_PORTS];
	gboolean  Nessus_En_Cours_De_Scan;
	gboolean  Nessus_Fini;  // donc on peut afficher les infos
	struct struct_Nessus *Nessus_Info_Debut;
	struct struct_Nessus *Nessus_Info_En_Cours;	
	struct struct_Index_Nessus *Index_Vunerabilite;
	struct struct_Index_Nessus *Index_Potentiel_Vunerabilite;
	struct struct_Index_Nessus *Index_Info;		
	int	Nb_Vulnerabilite_Nessus;
	int Nb_Potentiel_Vunerabilite_Nessus;
	int Nb_Info_Nessus;
};

struct struct_Machines Liste_Machines[MAX_MACHINE];
	
int       Nb_Station;
int       Nb_Serveur;
int       Nb_Machine_Trouve;

#endif
